c--versione 1.5.98
c
code for harpa
      subroutine harpa
c--dummy routine to identify the module
c
      return
      end
c
code for jhdir
      function jhdir(in)
c--read directives for Patterson automathic routine
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      dimension cod(30)
      equivalence(icod,cod)
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
c      integer*2     kstore(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c      equivalence(store,istore),(store,kstore)
c--
      dimension itarg(18)
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data nat/18/,ibro/2hbr/
      data itarg/4hprin,4hcycl,4hverb,4hloop,4hfudg,4htype,
     2		 4htabl,4hrefi,4hsect,4hscal,4hfixe,4hold ,
     3		 4hjump,4hdiff,4hview,4hrmax,4hchop,4hend /
c-- set default values
      jhdir=0
      nty=1
      ityp(1)=ibro
      do 1005 i=1,30
1005  icod(i)=0
      icod(1)=3
      icod(2)=-1
      icod(3)=-2
      icod(5)=-1
      icod(6)=3
c--codice itype per fourier (=3 fourier oss, =7 fourier diff 2fo)
      icod(14)=3
      icod(15)=0
      cod(16)=50.
      fud(1)=0.00001
      fud(2)=0.1
      fud(3)=0.5
      fud(4)=0.5
      do 1010 i=1,24
1010  ise(i)=0
      if(idefa(i)) 1000,1000,9000
1000  continue
      call sty(iarg)
c
c--main loop for processing input instructions
c--fetch the next card
 2000 continue
      if(klnc(2)) 9000,2020,9000
c-- card to be interpreted
 2020 continue
      call xpcci
      if(jrca(itemp,n)) 2060,2040,2060
c--process the directive
 2040 continue
      n=kcomp(1,itemp,itarg,nat,1)
      if(n) 2060,2060,2050
 2050 continue
      go to (2100,2200,2300,2400,2500,2600,
     2 2700,2800,2900,3000,3100,3200,3300,3400,
     3 3500,3600,3700,9000),n
2060  continue
      call xunkw
      go to 2000
c
c--'print' directive
 2100 continue
      icod(2)=0
      go to 2000
c
c--'cycle' directive
2200  continue
      icod(1)=kredi(i)
      if(icod(1).eq.0) icod(1)=3
      go to 2000
c
c--'verbose' directive
2300  continue
      icod(15)=2
      go to 2000
c
c--'loop' directive
2400  continue
      icod(6)=kredi(i)
      if(icod(6).eq.0) icod(6)=3
      go to 2000
c
c--'fudge' directive
2500  continue
      if(jredf(fud,4)) 2060,2092,2092
2092  continue
      if(fud(1).eq.0.0) fud(1)=1.0
      if(fud(2).eq.0.0) fud(2)=1.0
      if(fud(3).eq.0.0) fud(3)=1.0
      if(fud(4).eq.0.0) fud(4)=0.5
      go to 2000
c
c--'type' directive
 2600 continue
      nty=0
2605  continue
      nc=keq(nc,ib,2)
      if(nc) 2000,2000,2610
2610  if(jrcx(itemp(1),n,ib,2))2000,2620,2000
2620  continue
      nty=nty+1
      ityp(nty)=itemp(1)
      go to 2605
c
c--'table' directive
2700  continue
      nty=-1
      go to 2000
c
c--'read refinement' directive
2800  continue
      i=kredi(j)
      if(i.eq.5) icod(8)=1
      if(i.eq.12) icod(7)=1
      go to 2000
c
c--'section' directive
2900  continue
      do 2910 i=1,24
2910  ise(i)=1
2915  nc=kne(nc,ib,2)
      if(nc) 2000,2000,2920
2920  i=kredi(j)
      ise(i)=0
      go to 2915
c
c--'scale' directive
3000  continue
      icod(9)=1
      go to 2000
c
c--'fixed' directive
3100  continue
      i=kredi(j)
      icod(10)=i
      go to 2000
c
c--'old' directive
3200  continue
      icod(12)=1
      go to 2000
c
c--'jump' directive
3300  continue
      icod(13)=1
      go to 2000
c
c--'difference' directive
3400  continue
      icod(14)=7
      go to 2000
c
c--'view r(%)-factor'  directive
3500  continue
      icod(3)=2
      go to 2000
c
c--'rmax' directive
3600  continue
      if(jredf(temp,1)) 2060,3602,3602
3602  continue
      cod(16)=temp(1)
      if(cod(16).eq.0.0) cod(16)=50.0
      go to 2000
c
c--'chop reflections' directive
3700  continue
      if(jredf(temp,1)) 2060,3702,3702
3702  continue
      cod(17)=temp(1)
      go to 2000
c
c--'end' directive
9000  continue
      if(iabort)9010,9010,9100
9010  continue
      return
9100  continue
      iabort=0
      jhdir=1
      return
      end
c
code for pauto
      subroutine pauto
c--automatic solution of patterson map and  refinament.
c--
      include 'li6com.inc'
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst04/iw4,l4,m4,n4                                         
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,jdummy(17)
      character*60 iiscr,jjscr
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      dimension cod(30)
      equivalence(icod,cod)
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension ivet(15),bu(60),occel(20),npica(20),zel(20),zcon(20)
      dimension  idj(26),r(30),rmin(100),itran(100),iaccep(100)
      dimension ixy(3),x(3),y(3),xx(3),trasor(30),kfis(3),ielim(100)
      dimension ktenta(100,10),xvet(12),g(18)
      data ixy/1hx,1hy,1hz/
      data ista/1h*/
c--
      ijump=icod(13)
      dircho=cod(17)
      call stim1(1)
      itenta=1
      n5hea=1
2222  continue
c      if(itenta.gt.1)then
c      write(ncwu,*)'itenta,n5hea',itenta,n5hea
c      write(ncwu,*)'iaccep',(iaccep(j),j=1,n5hea)
c      do i=1,itenta-1
c      write(ncwu,*)'i,ktenta',i,(ktenta(j,i),j=1,n5hea)
c      enddo
c      endif
      if(itenta.gt.10)then
      write(ncwu,*)' Pauto cannot find a solution'
      return
      endif 
      call xcsae
      call xrsl
c--crea list 4 criterio unitario
      ix=6
      nnp=0
      call sc04(ix,nnp)
      call xfl04
      call sfl14
      if(store(l14g+4).eq.sys14) go to 1
      ix=0
      call sc014(ix)
1     call xcsae
      call xrsl
      itype=1
      iref=0
      iweig=0
      isearc=0
      iprint=0
      inte=3
      jq=-1
      call xfl01
      rvol=1.0/store(l1p1+6)
      scale=1.0
      call xfl02
      call xlat(temp)
      call xfl03
c--calculate the number of atoms in  the asymmetric unit
      fn=g2*n2
      focc=1.0/fn
      fatom=0.0
      occtot=0.0
      iheavy=0
      n3n=0
      zcont=0.
      do 10 i=1,20
      occel(i)=0.
      zcon(i)=0.
      zel(i)=0.
10    npica(i)=ib
      do  50 i= 1,n3
      m3=l3+(n3-i)*md3
      if(store(m3+13).gt.1.5)
     1 fatom=fatom+store(m3+12)*focc
c--17.4.98      if(store(m3+13).le.15)go to 50
      if(store(m3+13).le.16)go to 50
      iheavy=1
      zcon(i)=store(m3+13)*store(m3+12)*focc
      zcont=zcont+zcon(i)
      zel(i)=store(m3+13)
      npica(i)=istore(m3)
      occel(i)=store(m3+12)*focc
      occtot=occtot+occel(i)
c      write(ncwu,'(i5, 2x,a2)')i,npica(i)
11    format('      i,zcon(i),zel(i),npica(i),occel(i)'
     1 ,',store(m3+12) ',/,7x,i1,2x,2f7.2,4x,a2,2f6.2 )
c       write(ncwu,11)
c     1i,zcon(i),zel(i),npica(i),occel(i),store(m3+12)
      n3n=n3n+1
21    format(1x,2i10,a6,f10.3)
50    continue
      if(iheavy.eq.0)then
      write(ncwu,*)
     1 ' no heavy atoms present, the routine can not be run'
      return
      endif
48    format(/,1x,'not enought peaks present . the lightest ',
     1'specie considered is ',a2,', asymetric unit content = ',f9.2)
      if(np.gt.n15)np=n15
c      write(ncwu,*)' fatom = ',fatom
      call sfl14
      n5p =lint(l14g+11)
      a=store(l14g+8)
      isogl=kintk(a)
c      write(ncwu,*)' prima kfoupa, n.peak,isoglia',n5p,isogl
      r0=cod(16)
      ixx=0
      iyy=0
      kk=kfoupa(iyy,ixx,ntras,trasor,kfix,kfis)
c      write(ncwu,'(a2,f10.3)')
c     1 (npica(impica),occel(impica),impica=1,n3n)
      if(kk.lt.0)return
c-- Second section
c-- Determine the heavy atom(s) by structure factor calculations
c-- read down the lists
c      itenta=1
2000  continue
      call xcsae
      call xrsl
      call xfl01
      do  i=1,9
      g(i)   =store(l1m1+i-1)
      g(i+9)=store(l1m2+i-1)
      enddo 
      call xfl02
      call xlat(xvet)
      call xfl03
      call xfl04
      call sfl14
c--control the chop reflections 
      nanis=0
      call ctrlcho(dircho,fatom,nanis,chop,fomin,fomax)
      ichop=nint(chop)+1
      call crea6(1)
      call sfl15
      n015=n15
c      write(ncwu,*)'prima di cfct1 icod(15)+',icod(15)
c      write(ncwu,'(a2,f10.3)')
c     1 (npica(impica),occel(impica),impica=1,n3n)
      call cfact1(g,xvet,ntras,trasor,kfix,kfis,n15ini,n3n,
     1 r0,rfin,occel,occtot,npica,zel,ifin,kfin,ichop,itenta,nelim
     2 ,naccep,iaccep,ielim,ktenta)
c      write(ncwu,*)'  dopo cfact1 iaccep ',(iaccep(i15),i15=1,10)
c      write(ncwu,*)'  dopo cfact1 nelim,kfin,n15ini',nelim,kfin,n15ini 
c      call sw05(1,0)
      if(kfin.gt.0) return
      r0=rfin
      rheavy=rfin
      n5hea=n5
      if(n5.lt.fatom.and.n15.le.0)return
c
c-- Third section 
c-- Recovering the structure.
      if(icod(15).gt.0) write(ncwu,3041)
3041  format(/,' Recovering of the structure:') 
c-- read down the lists
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      call xfl03
      call xfl04
      call xfl06
      call crea6(0)
      call xfl05
      in=2
      inext=0
      if(jset12(in,inext,ladr,nsched).lt.0)go to 3000
      if(icod(15).gt.0)call sw12(1)
c      call sw05(1,0)
c--18.3.98
      in=1
c      write(ncwu,*)'nfl=',nfl
      iprx=0
      call calfac(in,iprx)
      rfin=rr(ichop)
c      write(ncwu,*)'dopo calfac r =',rfin
      in=0
      kact=5
      if(icod(15).gt.0)kact=4
      call calfou(kact,in)
      nflsav=nfl
c--fine 18.3.98
      rfina=rfin
      kcycl=1
c      npp=npicto*0.8-0.8*.00225*npicto**2
8000  continue
      nfl=nflsav
      if(icod(15).gt.0)write(ncwu,*)' CYCLE N.',kcycl
c      write(ncwu,*)' cycle number , nfl,npp ',kcycl,nfl,npp
      call xfl35
      call aggpk(n5hea,npp)
      call xfl06
      call crea6(0)
      call xfl05
      nk=kst53(ii)
      in=2
      inext=0
      if(jset12(in,inext,ladr,nsched).lt.0)go to 3000
      call cfact3(npicto,r0,rfin,kerr,ichop)
      cont5=0.
      m5=l5
      do j=1,n5
      cont5=cont5+store(m5+16)
      m5=m5+md5
      enddo
c      write(ncwu,*)'FINE CYCLE N,cont5,fatom',kcycl,cont5,fatom 
c      write(ncwu,*)'r after cycle n.',kcycl,rfin
c      write(ncwu,*)'kerr',kerr
      if(nelim.ge.n015.and.kerr.eq.2)then
          write(ncwu,*)' Pauto cannot find a solution '
      return
      endif
      if (cont5/fatom.gt.0.8.and.rfin.gt.25.and.
     1 kcycl.ge.3)go to 4000
      if(kerr.ge.1.or.rfin.ge.rheavy)go to 4000
c      if(icod(15).gt.0) write(ncwu,3054)r0
3054  format(' r(%) factor =',f6.2)
c      write(ncwu,*)'rfin,rfina,r0',rfin,rfina,r0
      if((rfin-rfina).lt.0.2.and.kcycl.ge.3)then
      if(rfin.lt.25)go to 9000
      endif
      if((rfin-rfina).gt.5.0)then
      idiverg=idiverg+1
          if(idiverg.ge.2)then
          write(ncwu,*)' the refinament diverges '
          return
          endif
      endif
      rfina=rfin
c      if(kerr.eq.1)then
c      write(ncwu,*)' errore in cfact3  '
c      return
c      endif
      kcycl=kcycl+1
      if(kcycl.le.5)go to 8000
4000  continue
c-- wrong tentative, begin a new trial
c      itenta=itenta+1
c--12.3.98      ina=1
c--12.3.98      if(naccep.eq.1)ina=0
c--12.3.98      iwrong=iaccep(naccep-ina)/100
c--14.4.97      iwrong=iaccep(naccep)
      do i=1,n5hea
      ktenta(i,itenta)=iaccep(i)
      iaccep(i)=0
      enddo
      itenta=itenta+1
c      ielim(nelim)=iwrong
c      nelim=nelim+1
c      write(ncwu,*)'---***---***---***---'
c      write(ncwu,*)'4000 itenta,iwrong,nelim,naccep,iaccep(naccep)'
c     1 ,itenta,iwrong,nelim,naccep,iaccep(naccep)
      go to 2222
9000  continue
c-- Fourth section
c-- Last calculations
c-- read down the lists
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      call xfl03
      call xfl04
      call xfl06
      call crea6(0)
c      call sw05(1,0)
      call clean5 
      call xfl05
      nj=kst53(ii)
      in=-1
      iprx=0
      call calfac(in,iprx)
c      write(ncwu,*)' Final Procedure'
      rfina=rr(ichop)
      write(ncwu,9090)rfina
9090  format(/,1x,'The atom(s) located by the routine ',
     1 'are the following (R(%) = ',f7.2,') :')
      call sw05(1,0)
c      write(ncwu,9091)rfina
9091  format(/,1x,'caculated fourier from the ',
     1 'atom(s) located by the routine (r(%) = ',f7.2,')') 
      idump=1
      ich=0   
      ilist5=1 
      kaction=4
      if(icldr(idump,iunchg,ilist5,kaction).ne.0)return
      call build(idump,iunchg,ilist5,kaction,ier)
      if(ier.ne.0)go to 3000
      return
3000  write(ncwu,*)' error in pauto  ,icrea12 '
      return
      end
c
code for ctrlcho
      subroutine ctrlcho(dircho,fatom,nanis,chop,fomin,fomax)
c--
      include 'li6com.inc'
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c-- fatom = n. atom u.a.
c-- nanis = no. anisotropic atoms present in list5 
      call xfl06
      idisc=1
      if(dircho.gt.0.01)then
      chop=dircho
      else
      discho=cutoff
      chop=discho
      if(chop.le.0.01)then
      call choicho(fatom,chop,nanis)
c      idisc=-1
      idisc=1 
      endif
      endif
      chop=idisc*chop
      l6d=l6a
      call dochop(chop,fomin,fomax)
      l6d=l6a
      return
      end
c
code for choicho
      subroutine choicho(fatom,chop,nanis)
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
c-- fatom = n. atom u.a.
c-- nanis = no. anisotropic atoms present in list5 
      chop=1
      ll=nfl
      nfl=ll+12
      do 101 ii=ll,nfl
101   istore(ii)=0
102   if(kldnr(in,vett).lt.0)go to 105
      sig=store(m6+4)
      ml=ll
      do 104 ij=1,10
      sigg=sig*ij
      if(store(m6+3).gt.sigg)istore(ml )=istore(ml )+1
104   ml=ml+1
      go to 102 
105   continue
      ml=ll
c      do 106 ij=1,10
c      write(ncwu,*)ij,istore(ml )
c106   ml=ml+1
      ilim=(4*fatom+nanis*5)*5.5
      ml=ll+3
      do 200 ij=4,7
      chop=ij-1
      if(istore(ml ).lt.ilim)go to 210
200   ml=ml+1
210   continue
      return
      end
c
code for kfoupa
      function kfoupa(iyy,ixx,ntras,trasor,kfix,kfis)
c--riporta sulla fourier il minimo picco patt. corrispondente
c--
      include 'li6com.inc'
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,inumb,l16x,l16y,n16x
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60 iiscr,jjscr
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/xtemp/itemp(80)
      dimension temp(80),cod(30)
      equivalence(itemp,temp),(icod,cod)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension ivet(15),bu(60),npic(200),vlat(12),occel(20),npica(20)
      dimension  idj(26),r(30),rmin(100),itran(100),iaccep(100)
      dimension ixy(3),x(3),y(3),xx(3),trasor(30),kfis(3)
      dimension izpk(500),zel(20),fcode(3)
      data ixy/1hx,1hy,1hz/
      data ista/1h*/
c      isavprint=iprint
c      iprint=3
c--
      kfoupa=0
      iiscr=iscr
      jjscr=jscr
c--
      call xlat(vlat)
      focc=1.0/(g2*n2)
      do 200 i=1,30
200   trasor(i)=0.0
      l= iortra(istore(l2s),ntras,trasor(4),kfix,kfis)
c      write(ncwu,*)'kfix,kfis,ntras,trasor ',kfix,kfis,ntras,trasor
c--      if(ijump.gt.0)go to 7000
      fcode(1)=1.
      fcode(2)=1.
      fcode(3)=1.
c      fcode(1)=1./4
c      fcode(2)=1./2
      call mhark(lmat,nmat,lm)
      call loadpa(ivet)
      l14=l14f
c      write(ncwu,*)' dopo loadpa '
c      write(ncwu,2)iscr
c      write(ncwu,2)jscr
2     format(1x,a80)
      il=lint(l14g+15)
      if((il.gt.3).or.(il.lt.1)) go to 9100
      im=lint(l14g+16)
      if((im.gt.3).or.(im.lt.1)) go to 9100
      iv=6-il-im
      if((iv.gt.3).or.(iv.lt.1)) go to 9100
c
      if(kfix.eq.1)then
      n=0
      do 100 i=1,3
      if(kfis(i).eq.0)go to 100
      if(n.eq.0)iv=i
      if(n.eq.1)im=i
      if(n.eq.2)il=i
      n=n+1
100   continue
      if(n.eq.2)il=6-iv-im
      if(n.eq.1)then
      if(iv.eq.im)im=6-iv-il
      if(iv.eq.il)il=6-iv-im
      endif
      endif
      pi2=pi/2.0
c
c--ilent=ioriz
c  imed =ivert                                                          
c  ivelox=isez                                                          
c                                                                       
c--set some values
      il1=il-1
      iv1=iv-1
      im1=im-1
c--      nq=jq
      jq=-1
c
c--calculate the number of points of the grid
c      write(ncwu,*)'kfix,kfisr ',kfix,kfis
      ljs=l14+iv1*md14
      ljv=l14+im1*md14
      ljo=l14+il1*md14
      store(ljs+1)=store(ljs+1-kfis(iv))
      store(ljo+1)=store(ljo+1-kfis(il))
      store(ljv+1)=store(ljv+1-kfis(im))
      jp= int((store(ljs+1)-store(ljs))/store(ljs+2)) + 1
      jp1=jp
      jm= int((store(ljo+1)-store(ljo))/store(ljo+2)) + 1
      jm1=jm
      jn= int((store(ljv+1)-store(ljv))/store(ljv+2)) + 1
      jn1=jn
      if(jq) 1051,1051,1052
1051  continue
      jm=jm+2
      jn=jn+2
      jp=jp+2
      store(ljo)=store(ljo)-store(ljo+2)
      store(ljv)=store(ljv)-store(ljv+2)
      store(ljs)=store(ljs)-store(ljs+2)
c
c--define some variable
1052  continue
      jd=0
      ilen=jn*jm
      irig=26
      m2a=l2
      m2b=l2+(n2-1)*md2
      d=1.0/360.0
      iminr=9999
      imaxr=-9999
      npag=jm1/irig
      if(npag*irig.ne.jm1) npag=npag+1
      l106=nfl
      nfl=l106+jm
      istore(l106)=store(ljo)
      m106=l106
      do 1065 i=2,jm
      istore(m106+1)=istore(m106)+store(ljo+2)
      m106=m106+1
1065  continue
      if(jq.eq.-1) l106=l106+1
      m14=l14
      do 1055 i=1,3
      div=store(m14+3)
      if(div.le.0.0) go to 9100
      m=m14
      do 1056 j=1,3
      store(m)=store(m)/div
      m=m+1
1056  continue
      m14=m14+md14
1055  continue
c
c--open  the first scratch file
      ilen1=18
      if(kkope(nctu,kscr,ier))9000,1057,1057
1057  continue
c      nrec=1
c
c--set the address for the areas to be used
c--area (map)
      lje=nfl
      ljg=lje
      ljg1=ljg
      if(jq.eq.-1) ljg1=ljg1+jm+1
      nfl=lje+ilen
      ljf=nfl-1
      do 1059 i=lje,ljf
1059  istore(i)=9999
      l=1
      call xsac(106,l,lji,ljf)
c--write the first scratch file
      istore(ljg  )=il
      istore(ljg+1)=im
      istore(ljg+2)=iv
      istore(ljg+3)=jm
      istore(ljg+4)=jn
      istore(ljg+5)=jp
      l=ljg+6
      m=ljo
      do 1061 i=1,4
      store(l)=store(m)
      l=l+1
1061  m=m+1
      m=ljv
      do 1062 i=1,4
      store(l)=store(m)
      l=l+1
1062  m=m+1
      m=ljs
      do 1063 i=1,4
      store(l)=store(m)
      l=l+1
1063  m=m+1
      write(nctu,iostat=ier,err=9000)ilen1
      m=ljg+ilen1-1
      write(nctu,iostat=ier,err=9000)
     1 (istore(i),i=ljg,m)
      close(nctu)
c--open  the second scratch file 
      ilen0=ilen*nbytes
      itypx=0
      if(kopen(nctu,lscr,ilen0,itypx,ier))9000,1067,1067
1067  continue
      nrec=1
      if(istat2.ne.0) call xpas
c
c--calculate the harker's vectors
      xs=store(ljs)
      do 2000 ii=1,jp
      lje1=lje
      xv=store(ljv)
      do 2200 ij=1,jn
      jheig=0
      xo=store(ljo)
      do 2400 ik=1,jm
      ipr=0
      x(il)=xo
      x(im)=xv
      x(iv)=xs
      kcon=-1
      istore(lje1)=99999
      m2a=lmat
      m2b=lmat+(nmat-1)*md2
      do 2500 l=m2a,m2b,md2
      kcon=kcon+1
      y(1)=x(1)*store(l)+x(2)*store(l+1)+x(3)*store(l+2)+store(l+ 9)
      y(2)=x(1)*store(l+3)+x(2)*store(l+4)+x(3)*store(l+5)+store(l+10)
      y(3)=x(1)*store(l+6)+x(2)*store(l+7)+x(3)*store(l+8)+store(l+11)
c--check if this position is included in the asymmetric unit
      ja=jassun(y,ivet,ipr,vlat,1)
      if(ja.gt.0)then
      write(ncwu,*)'jassun y :  ',y(1),y(2),y(3)
      go to 2555
      endif
c--read the patterson's peak
      iwrite=0
      leg=leggpa(y,iheig,ivet,iwrite)
      mm=istore(lm+kcon)
      if(leg.gt.0)go to 2555
c--store in the fourier buffer
      if(iheig.lt.istore(lje1))then
      istore(lje1)=iheig
      if(iheig.gt.imaxr)imaxr=iheig
      if(iheig.lt.iminr)iminr=iheig
      endif
2555  continue
2500  continue
      lje1=lje1+1
2400  xo=xo+store(ljo+2)
2200  xv=xv+store(ljv+2)
c--stampa e scrive su disco
      if(iprint.lt.2)go to 2300
c--print a layer
      ljg2=lje
      m106=l106
      jm2=jm1
      do 2385 m=1,npag
      nn=min0(jm2,irig)
      do 2335 i=1,nn
      idj(i)=istore(m106)
      m106=m106+1
2335  continue
      jm2=jm2-nn
      call sprtn
      i=kintk(xs*store(ljs+3))
      write(ncwu,2330) ixy(iv),i,ixy(il),ixy(im)
2330  format(1x,a1,2h =,i3,2x,7h layer,,3x,
     2 a1,8h across,,3x,a1,5h down,/)
      write(ncwu,2350) (idj(i),i=1,nn)
2350  format(/,8x,26i4)
      write(ncwu,2349) (ista,i=1,nn)
2349  format(8x,26(3x,a1))
      a=store(ljv)
      if(jq.eq.-1) a=store(ljv)+store(ljv+2)
      l=ljg2
      do 2380 i=1,jn1
      lj=l+nn-1
      k=kintk(a*store(ljv+3))
      if(m.lt.2)then
      write(ncwu,2360) k,(istore(li),li=l,lj)
      endif
2360  format(/,1x,i4,1h*,2x,26i4)
      l=l+jm
      a=a+store(ljv+2)
2380  continue
      ljg2=ljg2+nn
2385  continue
2300  continue
      m=ljg+ilen-1
      write(nctu,rec=nrec,iostat=ier,err=9000)
     1 (istore(i),i=ljg,m)
      nrec=nrec+1
c--increases the layer coordinate
2000  xs=xs+store(ljs+2)
c                                                                       
c--end of loop                                                          
      if(iprint.gt.1) call xline
      if(iyy.eq.0) go to 2316
      write(ncwu,2315) iminr,imaxr
2315  format(	 10h minimum =,i5,14h and maximum =,i5,
     2 13h values of ro)
c--test for peak scan
2316  continue
      close(nctu)
      iscr=lscr
      jscr=kscr
      ixx=-1
      itype=3
      call scan(ixx,iyy,i15)
c      write(ncwu,*)'dopo scan, i15=',i15
      if(i15.lt.0)then
      write(ncwu,*)' minimum function: not peak found ! '
      go to 9020
      endif
c      write(ncwu,*) 'list 15 prima di redpea ntras=',ntras
c        call sw15
c--reduce the number of peaks
c      iprint=isavprint
      call redpea(ntras,trasor)
c        call sw15
7000  continue
c      call choipko(ifin,np,npic,npicto,occel,npica,zel)
c        call sw15
      im=inmatt(in)
      if(icod(15).gt.0) then
        write(ncwu,7001)
7001    format(/,' peak(s) coming from minimum function:')
        call sw15
      end if
      iscr=iiscr
      jscr=jjscr
c--
c      if(np.eq.0)go to 9200
      return
9000  continue
      write(ncwu,9010) ier,nrec
9010  format(' foupa: ',2i5,' error  nrec')
9020  continue
      call xerr
      kfoupa=-1
      return
9100  continue
      write(ncwu,9110)
9110  format(' kfoupa: error on list 14!')
      go to 9020
c9200  continue
c      write(ncwu,9210)
c9210  format(' kfoupa: no acceptable peak present !')
c      go to 9020
      end
c
code for loadpa
      subroutine loadpa(ivet)
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,iserc,n5p,inte,iref
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xdisu/ncdfu ,ndfle,irecx,ldaf,nbytes
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension ivet(15)
c--
c--ilent=ioriz
c  imed =ivert                                                          
c  ivelox=isez                                                          
c--read the first scratch file
      ljg=nfl
      ljo=ljg+18
      ljv=ljo+4
      ljs=ljv+4
      nfl=ljs+4
c--open the first  scratch file
c      write(ncwu,*)'loadpa prima kopen',nctu,jscr,ier
      if(kkope(nctu,jscr,ier))9000,1057,1057
1057  continue
c      write(ncwu,1059)jscr
1059  format(1x,a80)
      read(nctu,iostat=ier,err=9000)ilen
      m=ljg+ilen-1
      read(nctu,iostat=ier,err=9000)
     1 (store(i),i=ljg,m)
c      write(ncwu,*)'loadpa jscr',(store(i),i=ljg,m)
      read(nctu,iostat=ier,err=9000)n15pat,md15
c      write(ncwu,*)' n15pat,md15 ',n15pat,md15
      l15tmp=nfl
      nn=n15pat*md15
      nfl=nfl+nn
      m=l15tmp+nn-1
      read(nctu,iostat=ier,err=9000)
     1 (istore(i),i=l15tmp,m)
      m15=l15tmp
c      do 10 i=1,n15pat
c      write(ncwu,*)(store(m15+ii-1),ii=1,md15)
c10    m15=m15+md15
      ilp=istore(ljg  )
      imp=istore(ljg+1)
      ivp=istore(ljg+2)
      jmp=istore(ljg+3)
      jnp=istore(ljg+4)
      jpp=istore(ljg+5)
      l=ljg+6
      m=ljo
      do 1061 i=1,4
      store(m)=store(l)
      l=l+1
1061  m=m+1
      m=ljv
      do 1062 i=1,4
      store(m)=store(l)
      l=l+1
1062  m=m+1
      m=ljs
      do 1063 i=1,4
      store(m)=store(l)
      l=l+1
1063  m=m+1
      m=ljg+ilen-1
      il1=ilp-1
      im1=imp-1
      iv1=ivp-1
      close(nctu)
      ilenp=jmp*jnp
c--open the second scratch file 
      ilen0=ilenp*nbytes
      itypx=0
c      write(ncwu,*)'ilenp,nbytes',ilenp,nbytes
c      write(ncwu,*)'loadpa prima kopen',nctu,ilen0,itypx,ier
c      write(ncwu,'(a)')iscr
      if(kopen(nctu,iscr,ilen0,itypx,ier))9000,1067,1067
1067  continue
      nrec=1
c--set some values
      lind=nfl
      nfl=lind+ilenp*jpp
c      write(ncwu,*)'lind, nfl,lfl ',lind, nfl,lfl
      if(nfl.ge.lfl)then
      write(ncwu,1058)
1058  format('loadpa : not enought room on store ')
      go to 9020
      endif
      mind=lind
      do 2000 j=1,jpp
      m=mind+ilenp-1
      read(nctu,rec=nrec,iostat=ier,err=9000)
     1 (istore(i),i=mind,m)
c      mindx=mind
c      do 2222 j22=1,jnp
c      write(ncwu,2350)(istore(i),i=mindx,mindx+jmp-1)
c2222  mindx=mindx+jmp
c      write(ncwu,*)'---------------'
      nrec=nrec+1
2000  mind=mind+ilenp
2350  format(/,8x,26i4)
c-- ivet 1-3 ilent=asse oriz; imedio=asse vert; ivelox=asse sezione
      ipo=store(ljo+3)*store(ljo+2)
      ipv=store(ljv+3)*store(ljv+2)
      ips=store(ljs+3)*store(ljs+2)
c-- ivet 4-6 indirizzo di (xmin,xmax,passo,dimensione) per sez,vert,oriz
      ivet( 1)=ilp
      ivet( 2)=imp
      ivet( 3)=ivp
      ivet( 4)=ljo
      ivet( 5)=ljv
      ivet( 6)=ljs
c-- no. punti per sez,oriz,vert
      ivet( 7)=jmp
      ivet( 8)=jnp
      ivet( 9)=jpp
c-- ivet(10) =jmp*jnp
      ivet( 10)=ilenp
c-- ivet(11)=lind indirzzo della mappa patt.
      ivet( 11)=lind
c-- ivet(12) l15tmp indirzo della lista 15 temporanea
      ivet( 12)=l15tmp
c-- ivet 13-15 passo * dimensione per oriz,vert ,sez
      ivet( 13)=ipo
      ivet( 14)=ipv
      ivet( 15)=ips
c      write(ncwu,*)'loapa ilp,imp,ivp,ljs,ljv,ljo,jpp,jmp,jnp,
c     1 ilenp,lind,l15tmp',ivet
c      write(ncwu,*)'da ljo a +11', (store(lll),lll=ljo,ljo+11)
      close(nctu)
c      write(ncwu,*)'fine loadpa'
      return
9000  continue
      write(ncwu,9010) ier
9010  format(' loadpa : ',i5,' error')
9020  continue
      call xerr
      return
      end
c
code for leggpa
      function leggpa(y,iheig,ivet,iwrite)
c--   iwrite=0/1  legge/scrive patterson
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension ivet(15),y(3)
c
      leggpa=0
      ilp  =ivet( 1)
      imp  =ivet( 2)
      ivp  =ivet( 3)
      ljo  =ivet( 4)
      ljv  =ivet( 5)
      ljs  =ivet( 6)
      jmp  =ivet( 7)
      jnp  =ivet( 8)
      jpp  =ivet( 9)
      ilenp=ivet(10)
      lind =ivet(11)
      ipo  =ivet(13)
      ipv  =ivet(14)
      ips  =ivet(15)
     
c--
      yo=y(ilp)-store(ljo)
      yv=y(imp)-store(ljv)
      ys=y(ivp)-store(ljs)
c      ipo=store(ljo+3)*store(ljo+2)
c      ipv=store(ljv+3)*store(ljv+2)
c      ips=store(ljs+3)*store(ljs+2)
      jmpt=int(store(ljo+3))
      jnpt=int(store(ljv+3))
      jppt=int(store(ljs+3))
      no=yo*jmpt
      nv=yv*jnpt
      ns=ys*jppt
      no=no/ipo
      nv=nv/ipv
      ns=ns/ips
c      no=int(yo/store(ljo+2)+0.005)
c      nv=int(yv/store(ljv+2)+0.005)
c      ns=int(ys/store(ljs+2)+0.005)
c      jmpt=int(store(ljo+3))
c      jnpt=int(store(ljv+3))
c      jppt=int(store(ljs+3))
c      no=yo*jmpt
c      nv=yv*jnpt
c      ns=ys*jppt
      mind=lind+(ns)*ilenp+(nv)*jmp+(no)
      if(mind.lt.lind.or.mind.gt.lfl)then
      nlong=ilenp*jpp
      write(ncwu,*)'errore in leggpa y=  ',y
      write(ncwu,*)'lind,mind,ilenp,nlong ',lind,mind,ilenp,nlong
      write(ncwu,*)
     1' y(ilp),store(ljo),y(imp),store(ljv),y(ivp),store(ljs),',
     2 ' jmpt,store(ljo+3),jnpt,store(ljv+3),jppt,store(ljs+3),',
     3 ' no,nv,ns,mind',
     1y(ilp),store(ljo),y(imp),store(ljv),y(ivp),store(ljs),
     2jmpt,store(ljo+3),jnpt,store(ljv+3),jppt,store(ljs+3),
     3 no,nv,ns,mind
      leggpa=1
      return
      endif
      if(iwrite.eq.1)istore(mind)=iheig
      if(iwrite.eq.0)iheig=istore(mind)
      return
      end
c
code for jassun
      function jassun(y,ivet,ipr,vlat,iprod)
c--check if the y position is included in the asymmetric unit
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,iserc,n5p,inte,iref
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension ivet(15),xsup(3),xinf(3),x(3),y(3),z(3),a(3),vlat(12)
c
      jassun=1
      ilp  =ivet( 1)
      imp  =ivet( 2)
      ivp  =ivet( 3)
      ljo  =ivet( 4)
      ljv  =ivet( 5)
      ljs  =ivet( 6)
      jmp  =ivet( 7)
      jnp  =ivet( 8)
      jpp  =ivet( 9)
      ilenp=ivet(10)
      lind =ivet(11)
c--
c      write(ncwu,*)' jassun ivet ',ivet
      xsup(ivp)= store(ljs+1)+store(ljs+2)*iprod
      xinf(ivp)= store(ljs)
      xsup(ilp)= store(ljo+1)+store(ljo+2)*iprod
      xinf(ilp)= store(ljo)
      xsup(imp)= store(ljv+1)+store(ljv+2)*iprod
      xinf(imp)= store(ljv)
c      write(ncwu,*)'jassun xinf',xinf
c      write(ncwu,*)'jassun xsup',xsup
      m2a=l2
      m2b=l2+(n2-1)*md2
      do 10 i=1,3
      x(i)=y(i)
c      if(x(i).lt.0.and.abs(x(i)).lt.0.01)x(i)=0.0
10    continue
      do 200 l=m2a,m2b,md2
      z( 1 )=x(1)*store(l)+x(2)*store(l+1)+x(3)*store(l+2)
      z( 2 )=x(1)*store(l+3)+x(2)*store(l+4)+x(3)*store(l+5)
      z( 3 )=x(1)*store(l+6)+x(2)*store(l+7)+x(3)*store(l+8)
      n2pt=3*n2p
      do 170 k=1,n2pt,3
      z(1)=z(1)+vlat(k)
      z(2)=z(2)+vlat(k+1)
      z(3)=z(3)+vlat(k+2)
      do 100 i=1,3
90    continue
      if(abs(z(i)).ge.1.)then
      ix=1
      if(z(i).lt.0)ix=-1
      z(i)=z(i)-ix
      go to 90
      endif
      if(abs(z(i)).ge.0.5)then
      ix=1
      if(z(i).lt.0)ix=-1
      z(i)=z(i)-ix
      endif
100   continue
      do 150 i=1,3,2
      is=2-i
      a(1)=z(1)*is
      a(2)=z(2)*is
      a(3)=z(3)*is
c--check if this position is included in the asymmetric unit
      do 300 j=1,3
      if(a(j).lt.0.)a(j)=a(j)+1.
      if(a(j).lt.xinf(j))go to 150
      if(a(j).gt.xsup(j))go to 150
300   continue
      do 350 j=1,3
350   y(j)=a(j)
      jassun=0
      return
150   continue
170   continue
200   continue
c      write(ncwu,*)' jassun x',x
c      write(ncwu,*)' xinf ',xinf
c      write(ncwu,*)' xsup ',xsup
c      write(ncwu,*)' y ',y
c      write(ncwu,*)' x ',x
c      write(ncwu,*)' z ',z
c      write(ncwu,*)' a ',a
      return
      end
c
code for mhark
      subroutine mhark(lmat,nmat,lm)
c--calcolate the (i -r) matrices and the t translational vectors
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,iserc,n5p,inte,iref
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension ivet(15),xsup(3),xinf(3),x(3),y(3),z(3),a(3)
c
      lmat=nfl
c--
      m=lmat
      nmat=0
      m2b=l2+md2
      do 100 k=1,n2
      isom=1
      if(k.eq.1)go to 400
200   continue
c      write(ncwu,*)' k,isom,nmat,m2b ',k,isom,nmat,m2b
      nmat=nmat+1
      m2a=l2
      mp=m
      m2bp=m2b
      do 300 n=1,md2
      store( m )=store(m2a)-isom*store(m2b)
c      write(ncwu,*)'store( m ),store(m2a),store(m2b) ',
c     1 store( m ),store(m2a),store(m2b)
      if(n.ge.10.and.store(m).lt.0.)then
      if((store(m)+0.5).lt.0.01)
     1 store(m)=abs(store(m))
      endif
      m2a=m2a+1
      m2b=m2b+1
300   m=m+1
c      write(ncwu,1)(store(mmm),mmm=mp,m-1)
1     format( 4(3f10.5,/))
400   if(ic.eq.0.or.isom.eq.-1)go to 100
      m2b=m2b-md2
      isom=-1
      go to 200
100   continue
c-- calcola il fat. moltiplicativo della intensita'
      lm=m
      iline=3
      mm=m
      nfl=lm+nmat
      istore(mm)=iline
      if(n2.eq.1)return
      do 1000 i=1,nmat
      mmat=lmat+(i-1)*md2
      do 1100 n=1,3
      aa=0.
      do 1200 k=1,3
      aa=abs(store(mmat))+aa
1200  mmat=mmat+1
      if(aa.le.0.)iline=iline-1
1100  continue
      if(iline.eq.0)iline=1
      istore(mm)=iline
1000  mm=mm+1
c      write(ncwu,*)'mhark nmat, lm ',nmat,lm
c      write(ncwu,*)'ncodhark ',(mm,istore(m+mm-1),mm=1,nmat)
      return
      end
c
code for iortra
      function iortra(icode,ntrasl,vet,kfix,kfis)
c--function to define the origin translations
c--ntrasl :number of origin traslations
c--vet	 :origin traslations
c--kfix code to fix at least one axis, 0=no 1=yes
c--kfis axis to be fixed
c
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih
     1 ,numb(10),iplus, inus,ipoint,namh
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
c--
      character*10 strin1,strin2,idol
      character*60 ifil
      dimension icode(16),icode1(16),vet(30),buf(60),kfis(3)
c--
      idol='$$$$'
      l=0
      k=1
      do 20 i=1,16
      if(icode(i).eq.ib) then
      if((k.eq.1).or.(l.ne.1)) go to 20
      icode1(k)=icode(i)
      k=k+1
      l=0
      else
      icode1(k)=icode(i)
      k=k+1
      l=1
      endif
20    continue
      ip=ib
      do 30 i=k,16
      icode1(i)=ib
30    continue
c      write(ncwu,1111)(icode1(n),n=1,10)
      write(strin1,1000)(icode1(n),n=1,10)
1000  format(10a1)
1111  format(1x,10a1)
c
c--open the file with the origen translations information
      nlen=300
      if(jopens(ncau,jasun,nlen,ier))9000,1001,1001
1001  continue
c
c--find the space group
40    continue
      read(unit=ncau,fmt=1010,end=900) strin2,ntrasl,(buf(j),j=1,21)
c      write(ncwu,1212) strin2
c      write(ncwu,1213) ntrasl,(buf(j),j=1,21)
1010  format(a10,i3,21f10.5)
c1212  format(1x,a)
c1213  format(1x,i3,10f10.5,/,11f10.5)
      if(index(strin1,strin2).ne.0) go to 50
      if(index(idol,strin2).ne.0) go to 900
      go to 40
50    continue
      iortra=1
      call jnsua(ntrasl,buf,kfix,vet,kfis)
      nt=3*ntrasl
c      write(ncwu,11) strin2,ntrasl,kfix,(vet(j),j=1,nt)
11    format(1x,a10,2i6,/,3(/,1x,9f10.5))
      go to 920
c
c--error messages
900   continue
      if(istat2.ne.0) write(ncwu,1011)
1011  format(2x,'string not found')
910   continue
      iortra=0
920   continue
      close(unit=ncau)
      return
9000  continue
      if(istat2.ne.0) write(ncwu,1012)
1012  format(2x,'**error on open file $trasor$.dat')
      go to 910
      end
c
code for jnsua
      subroutine jnsua(ntrasl,buf,is,vet,kfis)
c--insert in "vet" the values read from the disc
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension vet(30),buf(60),kfis(3)
c--
      is=0
      if(ntrasl.lt.0)is=1
      iss=isign(1,ntrasl)
      ntras=iabs(ntrasl)-is
      do 10 i=1,3
10    kfis(i)=0
      if(ntrasl.lt.0)then
      do 20 i=1,3
      if(buf(i).lt.0)kfis(i)=1
20    continue
      endif
      ntrasl=ntras
      if(ntras.eq.0)return
      nt=ntras*3
      ni=1+3*is
      do 30 i=1,nt
      vet(i)=buf(ni)
      if(buf(ni).lt.0)vet(i)=0.
      ni=ni+1
30    continue
c      write(ncwu,11) ntras,(vet(j),j=1,nt)
c11    format(1x,i16,/,3(/,1x,9f10.5))
      return
      end
c
code for redpea
      subroutine redpea(ntras,trasor)
c--reduce the list of peaks by deleting the peaks
c  equivalent owing to the origen translation
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      dimension x(3),trasor(30),d(3),xx(3),y(3)
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      call xlat(temp)
      call xfl03
      call sfl15
c--
      dm=0.64
      nt=ntras+1
      m15=l15
      l15tmp=nfl
      mtmp=l15tmp
      nn=n15*md15
      nfl=nfl+nn
      do 10 i=1,nn
      store(mtmp)=store(m15)
      mtmp=mtmp+1
10    m15=m15+1
      m15=l15tmp
      do 100 i=1,n15-1
      kintke=int(store(m15+6))
      if(kintke.le.0)go to 90
      x(1)=store(m15+3)
      x(2)=store(m15+4)
      x(3)=store(m15+5)      
      m2=l2
      do 1100 jj=1,n2
      y(1)=x(1)*store(m2  )+x(2)*store(m2+1)+x(3)*store(m2+2)
      y(2)=x(1)*store(m2+3)+x(2)*store(m2+4)+x(3)*store(m2+5)
      y(3)=x(1)*store(m2+6)+x(2)*store(m2+7)+x(3)*store(m2+8)
      y(1)=y(1)+store(m2+9)
      y(2)=y(2)+store(m2+10)
      y(3)=y(3)+store(m2+11)
      m2=m2+md2
      seg=1.0
      do 1050 iii=1,2
      do 1055 ij=1,3
      y(ij)=seg*y(ij)
1055  continue
      seg=-1.0
      k2p=1
      do 1080 ik=1,n2p
c      write(ncwu,*)' k2p, temp(k2p) ',k2p,temp(k2p),temp(k2p+1),
c     1temp(k2p+2)
      do 1082 ij=1,3
      y(ij)=y(ij)+temp(k2p)
1082  k2p=k2p+1 
      do 200 j=1,nt
      do 220 ij=1,3
220   xx(ij)=y(ij)+trasor((j-1)*3+ij)
c      write(ncwu,*)' xx ',xx
      m=l15tmp+i*md15
      do 300 k=i+1,n15
      jinte=int(store(m+6))
      if(jinte.le.0)go to 290
      do 310 ij=1,3
      d(ij)=xx(ij)-store(m+ij+2)
c      write(ncwu,*)' d(ij),xx(ij),store(m+ij+2) ',
c     1 d(ij),xx(ij),store(m+ij+2)
      if(abs(d(ij)).gt.0.5)
     1	 d(ij)=d(ij)-sign(1.0,d(ij))
310   continue
      dist=store(l1m1  )*d(1)*d(1)
     1    +store(l1m1+4)*d(2)*d(2)
     2    +store(l1m1+8)*d(3)*d(3)
     3    +store(l1m1+1)*d(1)*d(2)*2.0
     4    +store(l1m1+2)*d(1)*d(3)*2.0
     5	  +store(l1m1+5)*d(2)*d(3)*2.0
      if(dist.gt.dm) go to 290
      store(m+6)=-jinte
      store(m+1)=i
290   m=m+md15
300   continue
200   continue
1080  continue
1050  continue
1100  continue
90    m15=m15+md15
100   continue
c--save new list 15
400   continue
      m=l15tmp
      m15=l15
      nn=0
      do 500 k=1,n15
      if(store(m+6).lt.0)go to 520
      nn=nn+1
      do 510 kk=1,md15
510   store(m15+kk-1)=store(m+kk-1)
      m15=m15+md15
520   m=m+md15
500   continue
      n15=nn
      call frm15
c      call sw15
      return
      end
c
code for choipko
      subroutine choipko(ifin,np,npic,na,occel,npica,zel)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,jdummy(17)
      common/ylimi/nfl,lfl,idummy(5)
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/xnclu/ncmu,nctu,ncau,ncsu
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension npic(200),occel(20),npica(20),zel(20),zcon(20),hl(12)
c-- l3dum:n.at.nella u.a.,raggio,z,dmin,dmax
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      focc=1.0/(g2*n2)
      call xlat(hl)
      call xfl03
      call sfl15
c
      np=0
      n3n=0
      zcont=0.
      do 10 i=1,20
      occel(i)=0.
      zcon(i)=0.
      zel(i)=0.
10    npica(i)=ib
      if(zcont.le.0)zcont=1.
      sto0=1
      do  50 i= 1,n3
      m3=l3+(n3-i)*md3
c--17.4.98      if(store(m3+13).le.15)go to 50
      if(store(m3+13).le.18)go to 50
      zcon(i)=store(m3+13)*store(m3+12)*focc
      zcont=zcont+zcon(i)
      zel(i)=store(m3+13)
      npica(i)=istore(m3)
      occel(i)=store(m3+12)*focc
c      write(ncwu,'(i5, 2x,a2)')i,npica(i)
1     format('choipko i,zel(i),npica(i),   pmt,occel(i),ifin,focc'
     1 ,',store(m3+12) ',/,7x,i1,2x,f5.2,4x,a2,2f6.2 ,i4,2f6.2)
c       write(ncwu,1)
c     1i,zel(i),npica(i),pmt,occel(i),ifin,focc,store(m3+12)
      n3n=n3n+1
21    format(1x,2i10,a6,f10.3)
50    continue
48    format(/,1x,'not enought peaks present . the lightest ',
     1'specie considered is ',a2,', asymetric unit content = ',f9.2)
      if(np.gt.n15)np=n15
c      na=int(pmt)     
      call xfl03 
      return
      end
c
code for choipkold
      subroutine choipkold(ifin,np,npic,na,occel,npica,zel)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,jdummy(17)
      common/ylimi/nfl,lfl,idummy(5)
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/xnclu/ncmu,nctu,ncau,ncsu
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension npic(200),occel(20),npica(20),zel(20),zcon(20),hl(12)
c-- l3dum:n.at.nella u.a.,raggio,z,dmin,dmax
      call xcsae
      call xrsl
      call xfl01
      call xfl02
      focc=1.0/(g2*n2)
      call xlat(hl)
      call xfl03
      jump=-12
      call sortz(l3,n3,md3,jump)
      call sfl15
c
      np=0
      n3n=0
      m0=1
      mm=0
      pmt=0.
      zcont=0.
      do 10 i=1,20
      occel(i)=0.
      zcon(i)=0.
      zel(i)=0.
10    npica(i)=ib
      m3=l3
      do 20 i=1,n3
      if(store(m3+13).le.10)go to 20
      zcon(i)=store(m3+13)*store(m3+12)*focc
      zcont=zcont+zcon(i)
      write(ncwu,*)'choipko zcont,i,zcon(i)',zcont,i,zcon(i)
20    m3=m3+md3
      if(zcont.le.0)zcont=1.
      sto0=1
      m3=l3
      do  50 i= 1,n3
      if(store(m3+13).le.1)go to 50
      zel(i)=store(m3+13)
      npica(i)=istore(m3)
      pmt=pmt+store(m3+12)*focc
      occel(i)=pmt
      write(ncwu,'(i5, 2x,a2)')i,npica(i)
1     format('choipko i,zel(i),npica(i),   pmt,occel(i),ifin,focc'
     1 ,',store(m3+12) ',/,7x,i1,2x,f5.2,4x,a2,2f6.2 ,i4,2f6.2)
       write(ncwu,1)
     1i,zel(i),npica(i),pmt,occel(i),ifin,focc,store(m3+12)
c      if(store(m3+13).lt.20)go to 50
      s1=store(m3+13)/sto0
      s2=zcon(i)/zcont
      write(ncwu,*)'i,zcont,zcon(i),s2',i,zcont,zcon(i),s2
      write(ncwu,*)'sto0,store(m3+13),s1',sto0,store(m3+13),s1
c5.3.98      if(s1.lt.0.30.or.s2.lt.0.35)go to 50
      if(s1.lt.0.30.or.s2.lt.0.25)go to 50
      sto0=store(m3+13)
      ifin=i
      n3n=n3n+1
      pm =store(m3+12)*focc
      mp=int(pm)
      write(ncwu,*)' m0,mm,ifin,n3n,pm,mp ',m0,mm,ifin,n3n,pm,mp
      am=abs(pm-mp)
      if(am.gt.0.01)mp=mp+1
      mm=mm+mp
      write(ncwu,*)' am,mp,mm,m0 ',am,mp,mm,m0
      do 30 j=m0,mm
      npic(j)=istore(m3)
      np=j
      write(ncwu,'(a,2i5,a2,f10.5)')
     1 'j,np,npica(j),occel(j)',j,np,npica(j),occel(j)
30    continue
21    format(1x,2i10,a6,f10.3)
      m0=mm+1
50    m3=m3+md3
48    format(/,1x,'not enought peaks present . the lightest ',
     1'specie considered is ',a2,', asymetric unit content = ',f9.2)
      if(np.gt.n15)np=n15
      na=int(pmt)     
      call xfl03 
      return
      end
c
code for crea5
      subroutine crea5(n15n,nn)
c--calculate the list5
c--
      include 'li6com.inc'
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst15/l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
1000  continue
      call xpre05
c      write(ncwu,*) ' CREA5 3  l15' ,l15
      n5=0
      gmed=-1.0
      bmed=3.5
c      if(sc.gt.0.0) gmed=sc
c      if(bt.gt.0.0) bmed=bt
      store(l5o)=gmed
      store(l5o+1)=bmed
      m5=l5
      m15=l15
c      write(ncwu,*)'crea5  l15,l5,n15n ',l15,l5,n15n
      do 51 i=1,n15n
c      write(ncwu,'(a,a2,f10.3,i8)')
c     1 'istore(m15),store(m15+1),m15  ',istore(m15),store(m15+1),m15
      li=m5+md5-1
      do 1035 l=m5,li
      store(l)=0.0
1035  continue
      if(nn.eq.-1)then
      if(store(m15+2).lt.0)go to 53
      endif
      istore(m5)=istore(m15)
      m5h=m5+md5h
      do 1116 li=m5h,m5h+3
      istore(li)=ib
1116  continue
      store(m5+5)=store(m15+1)/100
      store(m5+16)=store(m15+7)
      store(m5+9)=bmed
      store(m5+md5xyz  )=store(m15+3)
      store(m5+md5xyz+1)=store(m15+4)
      store(m5+md5xyz+2)=store(m15+5)
      call xlabel(istore(m5),store(m5+5),istore(m5h))
      m5=m5+md5
      n5=n5+1
53    continue
      m15=m15+md15
  51  continue
      store(nfl+10)=float(n5)
      l5d=nfl
      n5d=m5-nfl
      call xfrm5
c      call xfrml(5 ,n)
c      call xdump
      nfl=m5
c      call sw05(1,0)
      call xfl05
      nj=kst53(ii)
      if(nj.lt.0) write(ncwu,*)' Warning! crea5 error!'
      return
      end
c
code for idoppion 
      function idoppion(nn,xvet,g)
c--controlla se il nuovo picco da inserire in lista 5 non e' gia presente.
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst15/l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension y(3),yy(3),z(3),x(3),d(3),xvet(12),vett(3,4),g(18) 
c--
      idoppion=0
      m=l15+(nn-1)*md15 +3
      do   n=1,3
      x(n)=store(m)
      m=m+1
      enddo
      m2=l2
      do 1100 i=1,n2
      y(1)=x(1)*store(m2  )+x(2)*store(m2+1)+x(3)*store(m2+2)
      y(2)=x(1)*store(m2+3)+x(2)*store(m2+4)+x(3)*store(m2+5)
      y(3)=x(1)*store(m2+6)+x(2)*store(m2+7)+x(3)*store(m2+8)
      y(1)=y(1)+store(m2+9)
      y(2)=y(2)+store(m2+10)
      y(3)=y(3)+store(m2+11)
      m2=m2+md2
      seg=1.0
      do 1055 jj=1,3
      y(jj)=seg*y(jj)
1055  continue
      seg=-seg
      ll=1
      do 1060 kkk=1,n2p
      do 1065 nnn=1,3
c      yy(nnn)=y(nnn)+vett(nnn,kkk)
      yy(nnn)=y(nnn)+xvet(ll+nnn-1)
1065  continue
c      write(ncwu,*)' nn,npk,y,yy',nn,npk,y,yy
      do npk=1,n15-1
      mm=l15+(npk-1)*md15 +3
      do   n=1,3
      z(n)=store(mm)
      d(n)=y(n)-z(n)
      mm=mm+1
      enddo
c      write(ncwu,*)' nn,npk,x,y,z,d',nn,npk,x,y,z,d
      distt=g(1)*d(1)*d(1)
     1    +g(5)*d(2)*d(2)
     2    +g(9)*d(3)*d(3)
     3    +g(2)*d(1)*d(2)*2.0
     4    +g(3)*d(1)*d(3)*2.0
     5    +g(6)*d(2)*d(3)*2.0
      dist0=sqrt(distt)
c      write(ncwu,*)' nn,npk,i,mm,distt,dist0'
c     1 ,npk,npk2,i,mm,distt,dist0
      if(dist0.lt.0.5)then
c      write(ncwu,*)' nn,npk,i,mm,distt,dist0'
c     1 ,npk,npk2,i,mm,distt,dist0
c      write(ncwu,*)' x,y',x,y
c      write(ncwu,*)' z,d',z,d
      idoppion=-1
      return
      endif
      enddo
      ll=ll+1
1060  continue
1100  continue
      return
      end
c
code for clean5
      subroutine clean5
c--eliminate atom having b(iso).ge.30.
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call xfl05 
      ns=nfl
      n=0
      bmax=30.
      m5=l5
      m5wr=l5
      do 1000 i=1,n5
      if(store(m5+9).ge.bmax)go to 1000
      n=n+1             
      do j=1,md5
       store(m5wr+j-1)=store(m5+j-1)
      enddo
      m5wr=m5wr+md5
1000  m5=m5+md5
      n5=n
      store(l5d+10)=float(n5)
      nfl=l5d
      n5d=m5wr-nfl
      call xfrm5
c      call xfrml(5,n)
c      call xdump
      nfl=ns
c      call sw05(1,0)
      call xfl05
      nj=kst53(ii)
      if(nj.lt.0) write(ncwu,*)' Warning! clean5 error!'
      return
      end
c
code for crea6
      subroutine crea6(ik)
c--create list 6 for structure factor calculation
c--
      include 'li6com.inc'
c
      dimension flist(2,12,1000)
      common/lst12/l12,m12,md12,n12,isca,ibm,nbl12,idra,idrb,l12d,n12d,
     2	ipol,iextin
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,
     2 ieq,iwe,nsca,nbm,iadsc,iadbm
      common/lst26/l26,m26,md26,n26,n26xa,n26xd,n26xe,icod26,
     1	n26p,l26d,n26d
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension ixyz(3),ixy(3),buf(8),ibuf(4,8)
      dimension jtabl(5),isc(3,3)
      data ixyz/1hx,1hy,1hz/
c--
      j=0
      il6=6
      icode=0
      call xsto6(il6,j,icode,in)
      lxxc=lxxe
      nxxc=nxxe
      njump=3
      if(ik.eq.1)call sortz(lxxe,nxxe,mdxxe,njump)
c     write(ncwu,4122)nxxe
c4122  format(' crea6 : number of reflections accepted =',i5)
      if(istat2.ge.4)then
      call xline
      mxxe=lxxe
      do l=1,10
      write(ncwu,4136) (store(m),m=mxxe,mxxe+6)
4136  format(3f10.0,7f10.3)
      mxxe=mxxe+mdxxe
      enddo
      endif
      return
      end
c
code for cfact1
      subroutine cfact1(g,xvet,ntras,trasor,kfix,kfis,n15ini,n3n,
     1 r0,rfin,occel,occtot,npica,zel,ifin,kfin,icho,itenta,nelim
     2 ,naccep,iaccep,ielim,ktenta)
c--sceglie la list 5 dalla 15 in funzione del r-minore
c--
      include 'li6com.inc'
c
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
c
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,inumb,l16x,l16y,n16x
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension ivet(15),bu(60),npic(200),dif(3),diff(3),coor(4)
      dimension  idj(26),r(100),rmin(100),itran(100),iaccep(100)
      dimension ixy(3),x(3),y(3),xx(3),yyy(3),trasor(30),kfis(3)
      dimension occel(20),npica(20),zel(20),ielim(100),rx(100)
      dimension iordr(100),ipicpat(100),rxall(100),sernu(100)
      dimension rcyc(3),xvet(12),g(18),ktenta(100,10)
c
c      write(ncwu,*)'occel',(occel(i),i=1,5)
      m2=l2
      mdd2=md2
c      write(ncwu,*)'trasor ',trasor
c      write(ncwu,*)'l2',l2,(store(ih),ih=m2,m2+md2*n2-1)
c      write(ncwu,*)'nfl',nfl
c      write(ncwu,*)'mdd2,md2',mdd2,md2
      kfin=0
      nxxe=400
      if(nxxc.lt.400)nxxe=nxxc
      nxxx=nxxe
      mxxx=mxxe
      lxxx=mxxx-nxxe*mdxxe
c      write(ncwu,*)'cfact1 reflections used : ',nxxe,lxxe
      npat=1
c      write(ncwu,*)' ntras,kfix,kfis ',ntras,kfix,kfis
      if(kfix.ne.0)then
      if(kkope(nctu,jscr,ier))9000,1050,1050
1050  continue
      read(nctu,iostat=ier,err=9000)ilen
c--      m=ljg+ilen-1
      read(nctu,iostat=ier,err=9000)jj
      read(nctu,iostat=ier,err=9000)n15pat,md15
      l15pat=nfl
      nn=n15pat*md15
      nfl=nfl+nn
      m=l15pat+nn-1
      read(nctu,iostat=ier,err=9000)
     1 (istore(i),i=l15pat,m)
c      m15=l15pat
c      do 10 i=1,n15pat
c      write(ncwu,*)(store(m15+ii-1),ii=2,md15)
c10    m15=m15+md15
      close(nctu)
      endif
c      write(ncwu,*)'occel',(occel(i),i=1,5)
c      iocpes=0
c      if(abs(occel(1)-int(occel(1))).gt.0.01)iocpes=1
      ifirst=1
      nt=ntras+1
      kmp1=n2+1
      kmp2=kmp1*(ntras+2)
c      write(ncwu,*)'kmp1,kmp2,n2,ntras',kmp1,kmp2,n2,ntras
      if(itenta.eq.1)then
      naccep=1
      nelim=1
      do  1020 i=1,100
      iaccep(i)=0
1020  ielim(i)=0
      endif
c      write(ncwu,*)'itenta,naccep,nelim',itenta,naccep,nelim
c      write(ncwu,*)'iaccep ', (iaccep(i),i=1,n15)
c      write(ncwu,*)'ielim  ',(ielim(i),i=1,n15)
      l15sav=l15
c      l15sav=nfl
c      nfl=l15sav+n15*md15
      m15=l15
      l15tmp=nfl
      mtmp=l15tmp
c      nn15=np
c      nnp=3*np
c      if(nnp.gt.n15)nnp=n15
      nnp=n15
      n015=n15
      nn=n15*md15
      nfl=nfl+nn
c      write(ncwu,*)'l15, nnp,occel(ifin),ifin ',l15,nnp,occel(ifin),ifin
c--
      l15=l15sav
      m15=l15
c      m15s=l15sav
      do  3010 i=1,100
      rx(i)=100.
      rxall(i)=0.
3010  r(i)=0.
      do  3020 i=1,100
      rmin(i)=100.
3020  itran(i)=0
c      write(ncwu,*)' l15sav,l15tmp,np,nnp,n015,nfl',
c     1 l15sav,l15tmp,np,nnp,n015,nfl
      do 3030 i=1,nn
      store(mtmp)=store(m15)
c      store(m15s)=store(m15)
      mtmp=mtmp+1
c      m15s=m15s+1
3030  m15=m15+1
c      write(ncwu,*)'kfis',kfis
      if(kfix.gt.0)then
      m15=l15tmp+2
      do 3040 i=1,n15
      do 3045 j=1,3
      if(kfis(j).eq.1)store(m15+j)=0.
c      write(ncwu,*)'i,j,kfis(j),store(m15+j)',i,j,kfis(j),store(m15+j)
3045  continue
3040  m15=m15+md15
      endif   
c-- cerca il massimo numero d'ordine 
      isermax=0
      m15=l15
      do i=1,n15
      ksenu=nint(store(m15+1)/100)
      if(ksenu.gt.isermax)isermax=ksenu
      m15=m15+md15
      enddo
c--
      ifound=0
      rbest=100
      ibest=0
      itran(1)=1
      rmin0=r0
      n15=1
      if(icod(15).gt.0) write(ncwu,3041)
3041  format(/,' location of the first heavy atom:') 
c      write(ncwu,*)'occel',(occel(i),i=1,5)
c
cc--se non primitivo (ill > 1) o triclino (n2=1) controlla 
cc--che il primo picco  non sia in posizione speciale
      if (ill.gt.1.or.n2.eq.1)then
      idum=0
      do iddd=3,5
      icoor=nint(abs(store(l15+iddd)*100))
      icoor=mod(icoor,100)
      if(icoor.eq.0.or.icoor.eq.50)idum=idum+1
      enddo
c      write(ncwu,*)'idum',idum
      endif
c--calcola il R per i singoli picchi
      r0prog=100.
      do 3050 i=1,n015
      m15s=l15tmp+(i-1)*md15
      fk15=store(m15s+7)
c      write(ncwu,*)' i,fk15,occel(1),iocpes ',
c     1 i,fk15,occel(1),iocpes
c      if(fk15.gt.occel(1))go to 3050
c      if(occel(1).le.1.and.fk15.lt.occel(1).and.iocpes.eq.0)go to 3050
      istore(l15)=npica(1)
      do ij=1,11
      store(l15+ij)=store(m15s+ij)
      enddo
c      write(ncwu,'(a,a2,i10)')'istore(l15),l15 ',istore(l15),l15
      n15n=n15
      call crea5(n15n,1)
1110    format(a,1x,2a4,2x,a2,f7.0,11f10.5)
      mm5=l5
      if(icod(15).gt.0) call sw05(1,0)
      lxxe=lxxx
      nxxe=nxxx
      in=-1
      iprx=0
c      if(i.eq.1) iprx=1
      call calfac(in,iprx)
c      write(ncwu,*)'dopo calfac icho,i',icho,i
      rx(i)=rr(icho)
      if(rx(i).lt.r0prog)r0prog=rx(i)
      lxxe=lxxc
      nxxe=nxxc
      in=-1
      iprx=0
c      if(i.eq.1) iprx=1
      call calfac(in,iprx)
c      write(ncwu,*)'dopo calfac icho,i',icho,i
      rxall(i)=rr(icho)
      if(i.eq.1)then
      iordr(1)=i
      else
      do ii=1,i-1
      k=iordr(ii)
c      write(ncwu,*)'ii,i,k,rx(i),rx(k)',i,ii,k,rx(i),rx(k)
        ik=0
        if(rx(i).lt.rx(k))then
        j=i-1
3051    iordr(j+1)=iordr(j)
        j=j-1
        if(j.ge.ii)go to 3051
        iordr(ii)=i
        ik=1
        go to 3052
        endif       
      enddo
3052  continue
      if(ik.eq.0)iordr(i)=i
      endif
      if(icod(15).gt.0) write(ncwu,3054)i,rx(i)
3054  format(' peak no.:',i3,'; r(%) factor =',f6.2)
3050  continue
      if(r0prog.gt.r0.and.r0prog.gt.80)then
      write(ncwu,*)' No solution with R-factor less than ',r0prog
      kfin=1
      return
      endif
      if(r0prog.gt.r0)then
      r0=r0prog+10
      if(r0.gt.80)r0=80.
      endif
c      write(ncwu,*)'rx ',(rx(j),j=1,n015)
c      write(ncwu,*)'rxall',(rxall(j),j=1,n015)
c      write(ncwu,*)'iordr',(iordr(j),j=1,n015)
c
2000  continue
      n15=1
      rmin0=r0
      do i=1,100
      r(i)=0.
      rmin(i)=100.
      itran(i)=0
      enddo
      itran(1)=1
c
c--accetta il primo atomo
      do 3055 ij=1,n015
      i1=iordr(ij)
      if(i1.eq.0)go to 3055
      m15s=l15tmp+(i1-1)*md15
      fk15=store(m15s+7)
c      write(ncwu,*)'occel',(occel(iki),iki=1,5)
      if(fk15.gt.occel(1))go to 3055
c       write(ncwu,*)' 3055 i1,rmin0,rx(i1)',i1,rmin0,rx(i1)
c--controlla se e' gia' stato eliminato 
      jeli=i1*kmp2+kmp1
      do 3053 ii=1,nelim
c      write(ncwu,*)' 3053 i1,ii,ielim(ii),nelim',i1,ii,ielim(ii),nelim
c      write(ncwu,*)' 3053 i1,rx(i1),rmin0',i1,rx(i1),rmin0
c      write(ncwu,*)'3053 i1,jeli,ii,ielim(ii)',i1,jeli,ii,ielim(ii)
      if(jeli.eq.ielim(ii))go to 3055
3053  continue
      if(itenta.gt.1.and.fk15.eq.occel(1))then
      iace=iaccep(1)
      iaccep(1)=jeli
      write(ncwu,*)'dopo 3053 prima ictrleli'
      kcontr=ictrleli(iaccep,ktenta,itenta)
      iaccep(1)=iace
      if(kcontr.eq.1)go to 3055
      endif
      if(rx(i1).gt.rmin0)go to 3055
c      if((fk15+0.001).lt.occel(1))fk150=fk15
      iaccep(1)=i1*kmp2+kmp1
c      write(ncwu,*)'iaccep(ij),ij,i1',iaccep(ij),ij,i1
      rmin(1)=rx(i1)
c      write(ncwu,*)'i1,rmin',i1,(rmin(iki),iki=1,20)
      rmin0=rx(i1)
      rall0=rxall(i1)
      go to 3056
c      write(ncwu,*)' r accepted i1,rmin(1),rmin0 ',i1,rmin(1),rmin0
3055  continue
c      write(ncwu,*)'i1, iaccep(i1),rx(i1),rxall(i1),rmin0,r0 ',
c     1iaccep(1),rx(i1),rxall(i1)
c     1 ,rmin0,r0
      if(rx(i1).ge.r0.and.fk15.eq.occel(1))then
      if(icod(15).gt.0) write(ncwu,*)' the best tentative found',
     1 ' is peak no. ',ibest,rbest
      endif
c      rmin0=rmin(1)
      l15=l15sav
3056  continue
      m15=l15
      ik=iaccep(1)/kmp2
      mtmp=l15tmp+(ik-1)*md15
c      write(ncwu,*)'l15tmp ,mtmp,iaccep(1) ,ik  '
c     1,l15tmp,mtmp,iaccep(1),ik
      do 3060 iki=1,md15
      store(m15)=store(mtmp)
      mtmp=mtmp+1
3060  m15=m15+1
      istore(l15)=npica(1)
      occ15=store(l15+7)
      sint0=store(l15+6)
      occ0=occ15
      ifound=1
      inume=iaccep(1)/kmp2
      if(inume.eq.0)go to 5000
c      write(ncwu,*)'iaccep(1),kmp2,inume',iaccep(1),kmp2,inume
c      if(rmin(1).ge.r0)then
c      go to 5000
c      endif
      if(icod(15).gt.0) write(ncwu,'(a,a,i5,f8.2)')
     1 ' The first heavy atom accepted',
     1 ' is peak no. ',inume,rmin(1)
c      write(ncwu,*)'****fine primo atomo***inume,rmin(1)',inume,rmin(1)
c      write(ncwu,*)'n3n,occ15,sint0 ',n3n,occ15,sint0
      if(occ15.eq.occel(n3n).and.n3n.eq.1)go to 5000
c
c--
c--following peaks : applying the allowed origen translations
      if(icod(15).gt.0) write(ncwu,3061)
3061  format(/,' location of the other heavy atoms:')
c      m2=l2
c      write(ncwu,*)'l2',l2,(store(ih),ih=m2,m2+md2*n2-1)
c      write(ncwu,*)'nfl',nfl
c      write(ncwu,*)'mdd2,md2',mdd2,md2
      rmin2=-1
      iatom=0
      n0=1
      if(occ15.eq.occel(1))then
      n0=2
      occ15=0
      endif
c
c--loop sulle specie
      do 3500 n=n0,n3n
c      write(ncwu,*)'3500 n',n
3499  continue
c      write(ncwu,*)'3499 n,n3n,occ15,occel(n3n),ifound'
c     1 ,n,n3n,occ15,occel(n3n),ifound
      if(n.eq.n3n.and.occ15.ge.occel(n3n))go to 5000
      if(ifound.eq.0)go to 5000
      jn=n15
      n15=n15+1
      ifound=0
      if(icod(15).gt.0) write(ncwu,*)'looking for the atom no.:',n15 
c--leggo da l15tmp scrivo in l15
      mm15=l15+md15*(n15-1)
      mtmp=l15tmp
c
c--loop sui picchi min.func.
      do 3100 i=1,n015
c      write(ncwu,*)'3100 i',i
c      write(ncwu,*)'l15,mm15,n15,l15tmp,mtmp,i,ooc15',
c     1   l15,mm15,n15,l15tmp,mtmp,i,occ15
      occk=occ15+store(mtmp+7)
c      write(ncwu,*)'i,occk ,occel(n),n,occel(n3n),n3n  '
c     1 ,i,occk,occel(n),n,occel(n3n),n3n
c--controlla l'occupazione
c      write(ncwu,'(1x,a2,i6,2f10.3)')npica(n),n,occk,occel(n)
      if(occk.gt.occel(n))go to 3100
c--controlla il rapporto delle int e degli z
      errin=abs(store(mtmp+6)-sint0*zel(n)/zel(1))/sint0
      errint=abs( (store(mtmp+6)*store(mtmp+7)/(sint0*occ0)) -
     1(zel(n)/zel(1)))
c      write(ncwu,*)'i,n,errin,errint,zel(1),zel(n),sint0,store(mtmp+6)
c     1 ,store(mtmp+7),occ0',i,n,errin,errint,zel(1),zel(n),
c     1 sint0,store(mtmp+6),store(mtmp+7),occ0
      if(errint.gt.0.6)go to 3100
c      write(ncwu,*)' nt, trasor  ',nt,(trasor(j),j=1,3*nt)
      do 3120 j=1,nt
3120  r(j)=0.
c
c--loop sulle origini permesse
      do 3200 j=1,nt
c      write(ncwu,*)'3200 j',j
      serialn=store(mtmp+1)
c--controlla se e' gia' stato accettato o eliminato
         if(kfix.eq.0)then
         indi=i*kmp2+j*kmp1
         jafin=n15-1
         if(n15.eq.1)jafin=1
         do jacc=1,jafin
         if(indi.eq.iaccep(jacc).or.indi.eq.ielim(jacc))go to 3200
         kace=iabs(iaccep(jacc))/kmp2
c         write(ncwu,*)'i,jacc,iaccep(jacc),kace,isermax,km2,mm15'
c     1   ,i,jacc,iaccep(jacc),kace,isermax,km2,mm15
            if(kace.eq.i)then
            isermax=isermax+1
            serialn=isermax*100
            endif
         enddo
            if(itenta.gt.1)then
c            write(ncwu,*)'n15,iaccep',n15,(iaccep(ni),ni=1,n15)
            iaccep(n15)=indi
            kcontr=ictrleli(iaccep,ktenta,itenta)
            iaccep(n15)=0
            if(occk.eq.occtot.and.kcontr.eq.1)go to 3200
            endif
         endif
      m15=mm15
      mt=mtmp
c      write(ncwu,*)'i,picco min.fun.',i,(store(k),k=mtmp+3,mtmp+5)
c      write(ncwu,*)'j,trasor  ',j,(trasor((j-1)*3+ih),ih=1,3)
      do 3250 k=1,md15
      store(m15)=store(mt)
      mt=mt+1
3250  m15=m15+1
      istore(mm15)=npica(n)
      store(mm15+1)=serialn
      store(mm15+3)=store(mm15+3)+trasor((j-1)*3+1)
      store(mm15+4)=store(mm15+4)+trasor((j-1)*3+2)
      store(mm15+5)=store(mm15+5)+trasor((j-1)*3+3)
      km1=l15+2
      km2=mm15+2
      k=0
      nl=0
c
c--controllo se vi e' una coordinata da definire
      if (kfix.eq.0)  go to 3350
      x(1)=store(mm15+3)
      x(2)=store(mm15+4)
      x(3)=store(mm15+5)
c
c--loop sugli op. di simm.
      mx2=l2
      do 3300 k=1,n2
c      write(ncwu,*)'3300 k',k
      y(1)=x(1)*store(mx2  )+x(2)*store(mx2+1)+x(3)*store(mx2+2)
      y(2)=x(1)*store(mx2+3)+x(2)*store(mx2+4)+x(3)*store(mx2+5)
      y(3)=x(1)*store(mx2+6)+x(2)*store(mx2+7)+x(3)*store(mx2+8)
      store(mm15+3)=y(1)+store(mx2+9)
      store(mm15+4)=y(2)+store(mx2+10)
      store(mm15+5)=y(3)+store(mx2+11)
c      write(ncwu,*)'j,k  ',j,k,(store(ih),ih=mm15+1,mm15+md15-1)
c--controlla se la diff. e' un picco patterson 
      idifx0=0
      do 3400 ni=1,3
c--22.4.98      difx=abs(store(km1+ni)-store(km2+ni))
      diff(ni)=abs(store(km1+ni)-store(km2+ni))
c--22.4.98      amm=amod(difx,1.)
c--22.4.98      if(amm.lt.0.03)idifx0=idifx0+1
c      write(ncwu,*)'difx, amod',difx,amm
      dif(ni)=0
c--22.4.98      diff(ni)=0
c--22.4.98      if(kfis(ni).eq.0)dif(ni)=amm
3400  continue
      call putinau(1,xvet,diff,dif)
c      write(ncwu,*)'kfix,idifx0,dif,kfis',kfix,idifx0,dif,kfis
c 6.3.98      if(idifx0.eq.3)go to 3100
c      write(ncwu,*)' dif ',dif
      mpat=l15pat+2
      do 3420 nj=1,n15pat
c      write(ncwu,*)'3420 nj',nj
c      write(ncwu,*)'nj, picco patt',nj,(store(mpat+nni),nni=1,3)
c      write(ncwu,*)'i,j,k,dif',i,j,k,dif
      nfin1=3
      do 3430 ni=1,3
      difx=abs(store(mpat+ni)-dif(ni))
      diff(ni)=amod(difx,1.)
c      write(ncwu,*)'ni,kfis(ni), diff(ni), ',
c     1 ni,kfis(ni),diff(ni)
      if(kfis(ni).eq.0.and.diff(ni).gt.0.05)go to 3420
      if(kfis(ni).eq.0)diff(ni)=0.
3430  continue
c
      xx(1)=store(km2+1)
      xx(2)=store(km2+2)
      xx(3)=store(km2+3)
c
c--loop sul segno
      do 3450 nl=1,nfin1,2
c      write(ncwu,*)'3450 nl',nl
      nll=2-nl
      do 3460 ni=1,3
3460  store(km2+ni)=xx(ni)+nll*diff(ni)*kfis(ni)
c      write(ncwu,*)' (km2) ',store(km2+1),store(km2+2),store(km2+3)
c-- controlla se e' gia stato accettato
      indi=(i*kmp2+j*kmp1+k)*(2-nl)
      nifin=n15-1
      if(n15.eq.1)nifin=1
      do ni=1,nifin
c      write(ncwu,*)'iaccep(ni),indi,ipicpat,i,j,k,nl',
c     1  iaccep(ni),indi,ipicpat(ni),i,j,k,nl
      if(indi.eq.iaccep(ni).and.j.eq.ipicpat(ni))go to 3450
      kace=iabs(iaccep(ni))/kmp2
c      write(ncwu,*)'ni,iaccep(ni),kace,isermax,km2,mm15'
c     1,ni,iaccep(ni),kace,isermax,km2,mm15
      serialn=store(km2-1)
      if(kace.eq.i)then
      isermax=isermax+1
      serialn=isermax*100
      store(km2-1)=isermax*100.
      endif
      enddo
      if(itenta.gt.1)then
      iaccep(n15)=indi
c      write(ncwu,*)'iaccep',(iaccep(ni),ni=1,n15)
      kcontr=ictrleli(iaccep,ktenta,itenta)
      iaccep(n15)=0
      if(occk.eq.occtot.and.kcontr.eq.1)go to 3450
      endif
c------
      n15n=n15
      call crea5(n15n,1)
      if(icod(15).gt.0) call sw05(1,0)
      lxxe=lxxx
      nxxe=nxxx
      in=-1
      iprx=0
      call calfac(in,iprx)
c      write(ncwu,*)'dopo calfac icho,i',icho,i
      r(j)=rr(icho)
c       write(ncwu,3455)i,j,k,r(j),rmin0
c--del 11.3.98
      jaff=0
      if(r(j).gt.rmin0+4.)go to 3450
c--aggiunto 15.4.98  if(n.eq.n3n...
      if(occk.eq.occel(n3n).and.n.eq.n3n.and.r(j).gt.50)go to 3450  
c15.4.98      if(occk.le.occel(n3n).and.r(j).gt.rmin0-1)then
      if(occk.eq.occel(n).and.r(j).gt.rmin0-1)then
      inn=2
      nflsav=nfl
      inext=0
      if(jset12(inn,inext,ladr,nsched).lt.0)go to 9200
      nfl=nflsav
c      write(ncwu,*)'cycaff in 3450'
      inn=-1
      nxxe=nxxc
      lxxe=lxxc
      iprx=0
      call calfac(inn,iprx)
c      if(rr(icho).gt.rall0)go to 3450
c      write(ncwu,*)'cycaff in 3450'
      call cycaff(inn,icho,rcyc)
      if(rcyc(1).eq.-1)go to 3450
      if(rmin2.eq.-1)rmin2=rcyc(3)
      r(j)=rcyc(3)
      if(n15.eq.2.and.r(j).gt.rall0)go to 3450
      jaff=1
      endif
c--fine del 11.3.98
c      write(ncwu,*)'mdd2,md2',mdd2,md2
c      write(ncwu,*)'mx2 ',mx2,k,(store(ih),ih=mx2,mx2+md2-1)
      if(icod(15).gt.0) write(ncwu,3455)i,j,k,r(j),rmin0
3455  format(' peak no.:',i3,';trans. app.:',i3,';n. op.:',i3,
     1';r(%) =',f6.2,';rmin0=',f6.2)
      if(r(j).gt.rmin0)go to 3450
      if(jaff.eq.1.and.r(j).gt.rmin2)go to 3450
      do 3465 ni=1,3
3465  coor(ni)=store(km2+ni)
      coor(4)=store(km2+5)
c      sint0=store(km2+4)
      sernu(n15)=serialn
      itran(n15)=j
c      write(ncwu,*)'2 iaccep',(iaccep(ni),ni=1,n15)
      iaccep(n15)=(2-nl)*(i*kmp2+j*kmp1+k)
c      write(ncwu,*)'3 iaccep',(iaccep(ni),ni=1,n15)
      ipicpat(n15)=nj
      naccep=n15
c      iaccep(n15)=i
      rmin(n15)=r(j)
      if(jaff.eq.0)rmin0=r(j)
      if(jaff.eq.1)rmin2=r(j)
      iatom=1
      ifound=1
3450  continue
c
3420  mpat=mpat+md15
3300  mx2=mx2+mdd2
c
c--fine sequenza se vi e' una coordinata da definire
      go to 3200
c--se non vi sono coordinate indefinite
3350  continue
c--22.11.99 deve controllare che non sia un doppione
      n15n=n15
c      write(ncwu,*)'dopo  3350, n15n,xvet,g',n15n,xvet,g
      idop=idoppion(n15n,xvet,g)
c      write(ncwu,*)'dopo  idoppion idop=',idop
      if(idop.eq.-1)go to 3200
      call crea5(n15n,1)
      if(icod(15).gt.0) call sw05(1,0)
      lxxe=lxxx
      nxxe=nxxx
      in=-1
      iprx=0
      call calfac(in,iprx)
      r(j)=rr(icho)
c      write(ncwu,*)'dopo calfac rr',rr
      if(icod(15).gt.0) write(ncwu,3456)i,j,r(j),rmin0
3456  format(' peak no.:',i3,';trans. app.:',i3,
     1';r(%) =',f6.2,';rmin0=',f6.2)
c      if(r(j).ge.rmin0)go to 3200
c--del 11.3.98
      jaff=0
      if(r(j).gt.rmin0+4.)go to 3200
c--aggiunto 15.4.98   if(n.eq.n3n...
      if(n.eq.n3n.and.occk.eq.occel(n3n).and.r(j).gt.50)go to 3200  
c15.4.98      if(occk.le.occel(n3n).and.r(j).gt.rmin0-1)then
      if(occk.eq.occel(n).and.r(j).gt.rmin0-1)then
      inn=2
      nflsav=nfl
      inext=0
      if(jset12(inn,inext,ladr,nsched).lt.0)go to 9200
      nfl=nflsav
c      write(ncwu,*)'cycaff in 3200'
      nxxe=nxxc
      lxxe=lxxc
      in=-1
      iprx=0
      call calfac(in,iprx)
      rcy0=rr(icho)
c      if(rcy0.gt.rall0)go to 3200
      inn=-1
      call cycaff(inn,icho,rcyc)
c      write(ncwu,*)' 3350 dopo cycaff,n5,rall0,rmin0,rcy0,rcyc'
c     1,n5,rall0,rmin0,rcy0,rcyc
      if(rcyc(1).eq.-1)go to 3200
      if(rmin2.eq.-1)rmin2=rcyc(3)
      r(j)=rcyc(3)
      if(n15.eq.2.and.r(j).gt.rall0)go to 3200
      if(n15.gt.2.and.r(j).gt.rmin0)go to 3200
      jaff=1
c      write(ncwu,*)'fine if'
      endif
c--fine del 11.3.98
      do 3355 ni=1,3
3355  coor(ni)=store(km2+ni)
      coor(4)=store(km2+5)
c      sint0=store(km2+4)
      sernu(n15)=serialn
      itran(n15)=j
c      write(ncwu,*)'4 iaccep',(iaccep(ni),ni=1,n15)
      iaccep(n15)=i*kmp2+j*kmp1
c      write(ncwu,*)'5 iaccep',(iaccep(ni),ni=1,n15)
      rmin(n15)=r(j)
      if(jaff.eq.0)rmin0=r(j)
      if(jaff.eq.1)rmin2=r(j)
      iatom=1
      ifound=1
3200  continue
c
3100  mtmp=mtmp+md15
c
c--Per un unica specie presente controlla se ha trovato il pezzo mancante
        if(iatom.eq.0.and.n15.gt.1)then
        inum=iaccep(n15-1)/kmp2
        ielim(nelim)=iaccep(n15-1)
        iaccep(n15-1)=0
        ipicpat(n15-1)=0
        if(icod(15).gt.0)write(ncwu,*)'eliminated peak no.',inum
            if(nelim.eq.n015)then
c            write(ncwu,*)' last tentative ifirst',ifirst 
            nnpp=1
            nelim=0
            ielim(1)=iaccep(1)
            ifirst=1+ifirst
            endif
        nelim=nelim+1
        if(ifirst.le.n015)go to 2000
        write(ncwu,*)' No solution with R-factor less than ',r0prog
        kfin=1
        return
        endif
c--controlla se ha trovato atomi per la i-essima specie
           if(ifound.eq.0)then
           n15=n15-1
           go to 3500
           endif
      j=itran(n15)
      naccep=n15
      iace=iabs(iaccep(n15)/kmp2)
      mtmp=l15tmp+(iace-1)*md15
      m15=mm15
      do 3600 k=1,md15
      store(m15)=store(mtmp)
      if(k.eq.2)store(m15)=sernu(n15)
      if(k.eq.4)store(m15)=coor(1)
      if(k.eq.5)store(m15)=coor(2)
      if(k.eq.6)store(m15)=coor(3)
      if(k.eq.8)store(m15)=coor(4)
      mtmp=mtmp+1
3600  m15=m15+1
c20.3.97      occ15=occk
c      occ15=0
c      sint0=store(mtmp+6)
      istore(mm15)=npica(n)
c      write(ncwu,*)'******* atomo accettato ******** ',iace
      n15n=n15
      call crea5(n15n,1)
c      call sw05(1,0)
      occk=occ15+store(mtmp+7)
      occ15=occk
      if(occk.lt.occel(n))go to 3499
      if(occ15.ge.occel(n))occ15=0
3500  continue
5000  continue
c-- list 5 finale
c-- controlla che i serial number non sia troppo grandi.
      ispecie=istore(l15)
      nnspecie=1
      do k=1,n15
      nspecie=nnspecie*100
      if(istore(l15+(k-1)*md15).eq.ispecie)then
      if(store(l15+(k-1)*md15+1).ne.nspecie)
     1 store(l15+(k-1)*md15+1)=nspecie
      nnspecie=nnspecie+1
      else
      ispecie=istore(l15+(k-1)*md15)
      nnspecie=1
      nspecie=nnspecie*100
      if(store(l15+(k-1)*md15+1).ne.nspecie)
     1 store(l15+(k-1)*md15+1)=nspecie
      nnspecie=nnspecie+1
      endif
      enddo 
c--fine controllo
      n15ini=n15
      call crea5(n15ini,1)
c      call sw05(1,0)
      in=2
      nflsav=nfl
      inext=0
      if(jset12(in,inext,ladr,nsched).lt.0)go to 9200
      nfl=nflsav
      in=-1
      nxxe=nxxc
      lxxe=lxxc
      iprx=0
      call calfac(in,iprx)
c      write(ncwu,*)'calfac in 5000'
      rcy0=rr(icho)
c      write(ncwu,*)'rall0,rr(icho),icho',rall0,rcy0,icho
c      if(rcy0.gt.rall0.and.iatom.eq.1)go to 5001
      inn=-1
c      write(ncwu,*)'cycaff in 5000(1)'
      call cycaff(inn,icho,rcyc)
c      write(ncwu,*)'dopo cycaff, rcy0,rcyc',rcy0,rcyc
      if(rcyc(1).eq.-1.or.rcyc(3).gt.rcy0)go to 5001
      if(n15.eq.1)go to 5003
      rcy1=rcyc(3)+0.002
      inn=-1
c      write(ncwu,*)'cycaff in 5000(2)'
      call cycaff(inn,icho,rcyc)
      if(rcyc(1).eq.-1)go to 5001
      if(rcyc(3).lt.rcy1)go to 5002
5001  nelim=nelim+1
      if(nelim.le.n015) then 
            if(nelim.gt.100) then 
            nelim=nelim-1
            goto 2000
            endif
      ielim(nelim)=iaccep(1)
      go to 2000
      endif
5002  if(rmin2.eq.-1)rmin2=rcyc(3)
c      if(rmin2.eq.-1)rmin2=rcyc(3)
5003  continue
      if(icod(15).gt.0)then
      write(ncwu,9090)rr(icho)
9090  format(/,' The heavy atom(s) located by the routine ',
     1 'are the following (r(%) = ',f7.2,') :')
      call sw05(1,0)
      endif
      rfin=rr(icho)                          
      return
9000  continue
      write(ncwu,9010) ier
9010  format(' cfact1 : ',i5,' error  jscr ')
      kfin=1
      return
9200  write(ncwu,*) ' cfact1 : error list 12 '
c      kfin=1
      return
      end
c
code for putinau
      subroutine putinau(kcode,xvet,x,vet)
c
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension xvet(12),x(3),y(3),vet(3),xmin(3),xmax(3)
      dimension rot(9),trans(3),ixvet(7)
c
c--kcode=1 patterson
c--kcode=2 fourier
      ixvet(1)=1
      ixvet(2)=2
      ixvet(3)=3
      ixvet(4)=4
      ixvet(5)=2
      ixvet(6)=2
      ixvet(7)=2
      jl=ill
      if(jl.eq.0)jl=1
      nlat=ixvet(jl)
c      write(ncwu,*)'nlat,ixvet',nlat,ixvet
      if(kcode.eq.1)nlat=1
      m14=l14p 
      if(kcode.eq.2)m14=l14f
      ifin=1
      if(kcode.eq.1.or.(kcode.eq.2.and.ic.eq.1))then
      ifin=2
      endif
      do i=1,3
      xmin(i)=store(m14)/store(m14+3)
      xmax(i)=store(m14+1)/store(m14+3)    
c      write(ncwu,*)'i,xmin,xmax',i,xmin(i),xmax(i)
      m14=m14+md14
      enddo
c      write(ncwu,*)'putinau x',x
      m2=l2
      do 1000 i =1,n2
      do 2000 jj=1,ifin
      j=3-2*jj
c      write(ncwu,*)' 2000 j',j
      mm2=m2
      do k=1,9
      rot(k)=store(mm2)
      mm2=mm2+1
      enddo
      do k=1,3
      trans(k)=0
      if(kcode.eq.2)trans(k)=store(mm2)
      mm2=mm2+1
      enddo
c      write(ncwu,'(a,9f6.0)')'putinau rot',rot
c      write(ncwu,'(a,3f6.3)')'putinau trans',trans
      y(1)=x(1)*rot(1)+x(2)*rot(2)+x(3)*rot(3)
      y(2)=x(1)*rot(4)+x(2)*rot(5)+x(3)*rot(6)
      y(3)=x(1)*rot(7)+x(2)*rot(8)+x(3)*rot(9)
      y(1)=j*(y(1)+trans(1))
      y(2)=j*(y(2)+trans(2))
      y(3)=j*(y(3)+trans(3))
c      write(ncwu,*)'putinau j y',j,y
      ll=1
      do 3000 l=1,nlat
c      write(ncwu,'(a,i5,3f6.3)')
c     1 'l,xvet',l,xvet(ll),xvet(ll+1),xvet(ll+2)
      do 3080 k=1,3
      vet(k)=y(k)+xvet(ll+k-1)
      ive1=ifix(vet(k))
c      vet(k)=vet(k)-ive1
c      ive2=int(vet(k))
c      write(ncwu,*)'k,ive1,vet(k)',k,ive1,vet(k)
3050  if(abs(vet(k)).le.0.5) go to 3075
      vet(k)=vet(k)-sign(1.0,vet(k))
      go to 3050
3075  continue
c      write(ncwu,*)'ultimo k,vet(k)',k,vet(k)
      if(vet(k).lt.xmin(k).or.vet(k).gt.xmax(k))go to 3000
3080  continue
c      vet(2)=y(2)+xvet(ll+1)
c      if(vet(2).lt.xmin(2).or.vet(2).gt.xmax(2))go to 3000
c      vet(3)=y(3)+xvet(ll+2)
c      if(vet(3).lt.xmin(3).or.vet(3).gt.xmax(3))go to 3000
c      write(ncwu,*)'putinua ok vet',vet
      go to 4000
3000  ll=ll+3
2000  continue
1000  m2=m2+md2   
c      write(ncwu,*)'-----errore in putinau------'
4000  continue
      return
      end  
c
code for ictrleli
      function ictrleli(iaccep,ktenta,itenta)
c
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension ktenta(100,10),iaccep(100)
c
      ictrleli=0
      it=itenta-1
      do 20 i=1,it
      do 10 j=1,n15
c      write(ncwu,*)'i,j,iaccep(j),ktenta(j,i)'
c     1 ,i,j,iaccep(j),ktenta(j,i)
      if(iaccep(j).ne.ktenta(j,i))go to 20
10    continue
      ictrleli=1
      return
20    continue
      return
      end    
c
code for cfact3
      subroutine cfact3(npicto,r0,rfin,kerr,icho)
c--
      include 'li6com.inc'
c
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,inumb,l16x,l16y,n16x
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
      common /restw/ dfr(3,500),qvr(3,500),kblock(500)
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension rcyc(3)
c--
      nfll=nfl
      in=1
      nxxe=nxxc
      lxxe=lxxc
      if(istat2.gt.0) call sw05(1,0)
      iprx=0
      call calfac(in,iprx)
      rcy0=rr(icho)
c      write(ncwu,*)' inizia cfact3 nfl' ,nfl
c      write(ncwu,*)' inizia cycaff'
c      call sw05(1,0)
c      write(ncwu,*)'cycaff in cfact3(1)'
      call cycaff(in,icho,rcyc)
c      write(ncwu,*)'dopo cycaff r0,rcyc',r0,rcyc
c 27.3.98      if(rcyc(1).eq.-1)then
      if(rcyc(1).eq.-1.or.rcyc(3).ge.r0)then
      kerr=2
      go to 2000
      endif
c      write(ncwu,*)' CFACT3 '
c      call sw05(1,0)
      sog=2
      if(rcyc(3).lt.30.)sog=3
      call viabbig(sog)
c      call sw05(1,0)
c      r0=rr(icho)
      in=1
      nxxe=nxxc
      lxxe=lxxc
      iprx=0
      call calfac(in,iprx)
c      write(ncwu,*)' nfl,  r = ',nfl,rr(icho)
      rfin=rr(icho)
      kerr=1
c      if(rr(icho).gt.r0)go to 2000
      kerr=0
c      do i =2,n5
c      kblock(i)=0
c      enddo
c      kblock(1)=1
      kact=5 
      if(icod(15).gt.0.)kact=4
      in=1
      if(rfin.lt.20)in=n5
      call calfou(kact,in)
      if(n15.le.0)kerr=1
2000  continue
      nfl=nfll
      return
      end
c
code for calfac
      subroutine calfac(in,iprx)
c--structure factors calculation
c
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      nj=kst53(ii)
c--controllare se la riga e' commentata
      if(icod(9).ne.0) go to 4160
      istatt=istat2
      istat2=0
c--i1=n.cycles
c--i2=n. di line per pagine (-1 no stampa)
c--i3=verbose
c--i4=0/-1  affina/non
c--i5 0/-1  affina scala/ non
c--sesta posizione fudge parametri posizionali
c--settima posizione fudge parametri termici
      i1=0
      i2=icod(2)
      if(iprx.eq.1) i2=0
c--      i2=0  per avere la stampa una riga per riflesso
      i3=icod(3)
      i4=-1
      i5=0
      if(jmnss(i1,i2,i3,i4,i5,fud(2),fud(3)))2000,4171,2000
 4171 continue
      i=kmnqd(in)
c      write(ncwu,*)'  calfac r = ',rr
c      i=kmnqd(in)
      istat2=istatt
 4160 continue
      return
2000  write(ncwu,*)' error in calfac ,jmnss '
      return
      end
c
code for calfou
      subroutine calfou(kact,nblock)
c--
      include 'li6com.inc'
c--
      common/xfour/ itype,iprint,numero,iweig,il  ,im  ,iv  ,isogl,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,inumb,l16x,l16y,n16x
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
      common/restw/ dfr(3,500),qvr(3,500),kblock(500)
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xnclu/ncmu,nctu,ncau,ncsu
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr,psfle,hlp1
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun,
     2 kkscr,llscr,psfle,hlp1
      character*60 iiscr,jjscr
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension ivet(15),npic(200),dif(3),diff(3)
      dimension  idj(26),r(30),rmin(100),itran(100),iaccep(100)
      dimension ixy(3),x(3),y(3),xx(3),trasor(30),kfis(3)
c
c-- nblock n. di atomi in list 15 da tenere blockati
c      write(ncwu,*)'inizia calfou'
      jjscr=jscr
      iiscr=iscr
      jscr=kkscr
      iscr=llscr
      call sfoss(icod(14))
      iyy=0
c      istat2=2
      if(kfour(iyy)) 9100,5100,5100
5100  continue
c      write(ncwu,*)' CALFOU'
c      call sw05(1,0)
c      do i=1,n5
c      kblock(i)=1
c      enddo
      ixx=1
      iyy=0
      call scan(ixx,iyy,i15)
      call sfl15
c      write(ncwu,*)'prima di aggpk15 store(m15+1)'
c      m15=l15+1
c      write(ncwu,*)(store(m15+(i-1)*md15),i=1,10)
      call aggpk15(nblock,kchang)
c      write(ncwu,*)'dopo aggpk15 store(m15+1)'
c      m15=l15+1
c      write(ncwu,*)(store(m15+(i-1)*md15),i=1,10)
      call frm15
c      write(ncwu,*)'nblock,kchang,kact  ',nblock,kchang,kact
      if(i15.lt.0)go to 5200
c      jscr=jjscr
c      iscr=iiscr
c      call sw15
      kactio=kact
      if(nblock.eq.0.and.kchang.eq.0.and.kact.ge.4)kactio=kact-3
c      write(ncwu,*)'kact,kactio',kact,kactio
      idump=1
      ich=0   
      ilist5=i15+100 
c      if(i15.eq.-1)ilist5=101
      if(icldr(idump,iunchg,ilist5,kactio).ne.0)return
      call build(idump,iunchg,ilist5,kactio,ier)
      if(ier.ne.0)go to 9200
5200  continue
      jscr=jjscr
      iscr=iiscr
      return
9100  continue
      write(ncwu,9110)
9110  format(' calfou: error on list 14!')
      return
9200  write(ncwu,*)'Errore in build Ier =',ier
      return
      end
c
code for cycaff
      subroutine cycaff(in,ichop,rcyc)
c--start 3 cycles of refinement
c--
      include 'li6com.inc'
c
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
c
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common/ylimi/nfl,lfl,nl,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workd/icod(30),ise(24),fud(4),nty,ityp(8),sumn,sumq,sigmaq
      common/xrefi/rr(7),rw(7),ss(7),shesd(2),difro(3)
      common/xtemp/itemp(80)
      dimension temp(40)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension rcyc(3)
c--
c--i1=n.cycles
c--i2=n. di line per pagine (-1 no stampa)
c--i3=verbose
c--i4=0/-1  affina/non
c--i5 0/-1  affina scala/ non
c--sesta posizione fudge parametri posizionali
c--settima posizione fudge parametri termici
c      write(ncwu,*)'inizia cycaff istat2 ',istat2
c
      kk=0
      do i=1,3
      rcyc(i)=0.
      enddo
c      call sw12(1)
      i1=3
      i2=-1
c      i3=2
c      i3=-1
      i3=icod(3)
      i4=0
      i5=-1
      fud(2)=1
      fud(3)=1
      istatt=istat2
      istat2=0
1030  kk=kk+1
      if(kk.gt.i1)go to 4160
      iuno=1
c      write(ncwu,*)'1 cycaff rcyc ',rcyc
      if(jmnss(iuno,i2,i3,i4,i5,fud(2),fud(3)))2000,4171,2000
 4171 continue
c      write(ncwu,*)'kk,in=',kk,in
      i=kmnqd(in)
c      write(ncwu,*)'i,in',i,in
      inn=1
      i=jsolv(inn)
      rcyc(kk)=rr(ichop)
c      write(ncwu,*)'cycaff ichop,rr',ichop,rr
      if(icod(15).gt.0)write(ncwu,4161)kk,rcyc(kk)
4161  format(' Refinement Cycle n.',i1,' R(%)= ',f6.2)
      if(kk.eq.1)go to 1030
c--controllare andamento di deltar 6.3.98
c15.4.98 d0=3.
      d0=-1.
      deltar=d0+(50.-rcyc(kk-1))/9.
c      write(ncwu,*)'controllo deltar, r,deltar',rcyc(kk-1),deltar
      if(kk.gt.1.and.rcyc(kk).lt.(rcyc(kk-1)+deltar))go to 1030
      rcyc(1)=-1
 4160 continue
      istat2=istatt
c      write(ncwu,*)'2 cycaff rcyc ',rcyc
      return
2000  write(ncwu,*)' error in cycaff ,jmnss '
      return
      end
c
code for viabbig
      subroutine viabbig(snum)
c
      common /lsql/ nAddComm,iPdire,icomatB,ipcomB,iFFour,amult,BLimit
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/ylimi/nfl,lfl,idummy(5)
      common/xchar/id,ie,ib,icc,ia,ih,jdummy(14)
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      blimi=snum*BLimit/5
      blimi=store(l5d+28)*snum
c      write(ncwu,*)'BLimit,blimi',BLimit,blimi
      nn5=n5
      nn=0
      mm5=l5
100   continue
      if(nn.ge.nn5)go to 1000
      if(store(mm5+10).gt.0.0)go to 200
      if(store(mm5+9).lt.blimi)go to 200
      nn5=nn5-1
      if(nn.eq.nn5+1)go to 1000
      mfin=l5+(nn5-1)*md5
      do i=mm5,mfin,md5
c      write(ncwu,'(i10,2x,a2,f10.4)')i,istore(i),store(i+5)
         do j=1,md5
         store(i+j-1)=store(i+j-1+md5)
         enddo
      enddo
      mm5=mm5-md5
200   nn=nn+1
      mm5=mm5+md5
      go to 100
1000  continue
      n5=nn5
      m5=l5+n5*md5
      nfll=nfl
      nfl=l5d
      istore(m5)=0
      store(nfl+11)=0.
      store(nfl+10)=float(n5)
      n5d=m5-nfl
      call xfrm5
      nfl=nfll
c      call sw05(1,0)
      call xfl05
      call xfl03
      nj=kst53(ii)
      if(nj.lt.0) write(ncwu,*)' Warning! viabbig error!'
c      write(ncwu,*)'lista 5 dopo viabbig'
c      call sw05(1,0)
      return
      end
c
code for aggpk
      subroutine aggpk(n5hea,npp)
c--
      include 'li6com.inc'
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/ylimi/nfl,lfl,idummy(5)
      common/xchar/id,ie,ib,icc,ia,ih,jdummy(14)
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/xnclu/ncmu,nctu,ncau,ncsu
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension numfr(100),itypk(100),ifrpk(100),npheig(3)
      data namec/2hc /
c-- l3dum:n.at.nella u.a.,raggio,z,dmin,dmax
c
      call xpre05
      n5=0
      gmed=-1.0
      bmed=3.5
c      if(sc.gt.0.0) gmed=sc
c      if(bt.gt.0.0) bmed=bt
      store(l5o)=gmed
      store(l5o+1)=bmed
cc      write(ncwu,*) ' aggpk,l5o,store(l5o),store(l5o+1) ='
cc     1 ,l5o,store(l5o),store(l5o+1)
cc      write(ncwu,*)' aggpk, l6p,store(l6p+17),store(l6p+18) ',
cc     1 l6p,store(l6p+17),store(l6p+18)
c
      m3=l3+(n3-1)*md3
10    continue
      if(m3.lt.l3)go to 20
      if(istore(l35).eq.istore(m3))then
      zconte=store(m3+13)
      rap=zconte/(store(l35+47)*store(l35+16))
c      write(ncwu,'(a,a2,4f10.5)')'ist(m3),rap,(m3+13),(l35+33),l35+11)',
c     1istore(m3),rap,store(m3+13),store(l35+33),store(l35+11)
      endif
      m3=m3-md3
      go to 10
20    continue      
      m5=l5
      m35=l35
cc      nn=1
cc      nsogl=npheig(nstrut)
      do 51 i=1,n35
      li=m5+md5-1
      do  l=m5,li
      store(l)=0.0
      enddo
      istore(m5)=istore(m35)
      if(i.le.n5hea)go to 100
      rapint=rap*store(m35+47)*store(m35+16)
      init=0
      if(store(l3+13).lt.1.5)init=1
      jnome=0
      delta=1000.
      m3=l3+init*md3
        do li=1+init,n3
	if(istore(m35).eq.istore(m3).and.
c--17.4.98     1  store(m3+13).gt.15)go to 100
     1  store(m3+13).gt.18)go to 100
        dife1=rapint-store(m3+13)
        dife=abs(dife1)
        if(delta.gt.dife)then
        delta=dife
        jnome=li
        endif
	m3=m3+md3
        enddo
      istore(m5)=istore(l3+(jnome-1)*md3)
100   continue
      m5h=m5+md5h
      do  li=m5h,m5h+3
      istore(li)=ib
      enddo
      store(m5+5)=store(m35+5)
      store(m5+16)=store(m35+16)
      store(m5+9)=store(m35+9)
      store(m5+md5xyz  )=store(m35+md5xyz  )
      store(m5+md5xyz+1)=store(m35+md5xyz+1)
      store(m5+md5xyz+2)=store(m35+md5xyz+2)
      call xlabel(istore(m5),store(m5+5),istore(m5h))
      m5=m5+md5
      n5=n5+1
      m35=m35+md35
51    continue
      npp=n5
      store(nfl+10)=float(n5)
      l5d=nfl
      n5d=m5-nfl
      call xfrm5
      nfl=m5
      call xfl05
      return
      end
c
code for aggpk15
      subroutine aggpk15(nblock,kchang)
c--
      include 'li6com.inc'
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/ylimi/nfl,lfl,idummy(5)
      common/xchar/id,ie,ib,icc,ia,ih,jdummy(14)
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20)
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst02/ic,ill,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/xnclu/ncmu,nctu,ncau,ncsu
      character*60  jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xscru/ jscr,iscr,kscr,lscr,iasun,iform,imsg,jasun
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      dimension numfr(100),itypk(100),ifrpk(100),npheig(3),jchang(20)
c--
      n5hea=n5
      kchang=1
      m3=l3+(n3-1)*md3
10    continue
      if(m3.lt.l3)go to 20
      if(istore(l15).eq.istore(m3))then
      zconte=store(m3+13)
      rap=zconte/(store(l15+6)*store(l15+7))
      endif
      m3=m3-md3
      go to 10
20    continue      
      m15=l15
c
      init=0
      if(store(l3+13).lt.1.5)init=1
      do 51 i=1,n15
      iblock=0
      if(i.le.nblock)iblock=1
      store(m15+1)=nint(store(m15+1)/100)*100+iblock
      iblock=0
      if(i.le.n5hea)go to 100
      m15i=m15
      rapint=rap*store(m15+6)*store(m15+7)
c      write(ncwu,*)'i,rapint,(m15+6),(m15+7),rap',i,rapint
c     1  ,store(m15+6),store(m15+7),rap
      jnome=0
      delta=1000.
      m3=l3+init*md3
        do li=1+init,n3
        if(istore(m15i).eq.istore(m3).and.
c--17.4.98     1  store(m3+13).gt.15)go to 100
     1  store(m3+13).gt.18)go to 100
        dife1=rapint-store(m3+13)
        dife=abs(dife1)
        if(delta.gt.dife)then
        delta=dife
        jnome=li
        endif
c        write(ncwu,'(i5,2x,a2,6f10.3)')
c     1  i,istore(m3),
c     1  store(m3+13),dife1,dife
        m3=m3+md3
        enddo
      istore(m15i)=istore(l3+(jnome-1)*md3)
      jchang(jnome)=jchang(jnome)+1
100   continue
      m15=m15+md15
51    continue
c-- if it recognized some peak as a specie kchang=1
      m3=l3
      do i=1,n3
      nlim=i
      if(istore(l15+(n5hea-1)*md15).eq.istore(m3))go to 200
      m3=m3+md3
      enddo
200   continue
c      write(ncwu,*)'aggpk15 nlim,jchang',nlim,(jchang(li),li=1,n3)
      if(nlim.eq.1)return
      if(jchang(nlim-1).eq.0)kchang=0
      return
      end
